/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function PanelDivision(id, divisionDomId, bCloseOnClickOut)
{
  this.init(id, divisionDomId, bCloseOnClickOut);
}
PanelDivision.prototype.init = function(id, divisionDomId, bCloseOnClickOut)
{
  this.id = id;
  this.divisionDomId = divisionDomId;
  this.bCloseOnClickOut = bCloseOnClickOut;
  this.visibilityBroker = null;
  this.bMousetouched = false;
  var me = this;
  this.outerClick = function(event)
  {
    ;
    ;
    ;
    var targetNode = Browser.getOriginalTargetFromEvent(event);
    var onDivision = false;
    while(targetNode.parentNode != null)
    {
      if(targetNode.id == me.divisionDomId)
      {
        onDivision = true;
        break;
      }
      targetNode = targetNode.parentNode;
    }
    if(!onDivision)
    {
      switch(event.type)
      {
        case 'mousedown':
          me.bMousetouched = true;
          Browser.eventStopPropagation(event);
          break;
        case 'mouseup':
          Browser.eventStopPropagation(event);
          break;
        case 'click':
          if(me.bMousetouched)
          {
            me.visibilityBroker.hide();
            me.removeEventListener();
          }
          Browser.eventStopPropagation(event);
          break;
      }
    }
  }
}
PanelDivision.prototype.setEventListener = function()
{
 ;
  Browser.addEventListenerToDomNode(document, Browser.eventNames.CLICK, this.outerClick);
  Browser.addEventListenerToDomNode(document, Browser.eventNames.MOUSEUP, this.outerClick);
  Browser.addEventListenerToDomNode(document, Browser.eventNames.MOUSEDOWN, this.outerClick);
}
PanelDivision.prototype.removeEventListener = function()
{
  ;
  Browser.removeEventListenerFromDomNode(document, Browser.eventNames.CLICK, this.outerClick);
  Browser.removeEventListenerFromDomNode(document, Browser.eventNames.MOUSEUP, this.outerClick);
  Browser.removeEventListenerFromDomNode(document, Browser.eventNames.MOUSEDOWN, this.outerClick);
  this.bMousetouched = false;
}
PanelDivision.prototype.setVisible = function(bVisible)
{
  ;
  if(this.bCloseOnClickOut)
  {
    if(bVisible)
    {
      this.setEventListener();
    }
    else if(!bVisible && !this.bMousetouched)
    {
      this.removeEventListener();
    }
  }
}
PanelDivision.prototype.setVisibilityBroker = function(visibilityBroker)
{
  this.visibilityBroker = visibilityBroker;
}
PanelDivision.prototype.start = function()
{
  if(this.visibilityBroker)
  {
    this.visibilityBroker.addShowHandle(this.getVisibleAction());
    this.visibilityBroker.addHideHandle(this.getHiddenAction());
  }
}
PanelDivision.prototype.getVisibleAction = function()
{
  return new ObjectMethodAction(this, "setVisible", true);
}
PanelDivision.prototype.getHiddenAction = function()
{
  return new ObjectMethodAction(this, "setVisible", false);
}
