/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
TextToggleButton.prototype             = new DomletCtr();
TextToggleButton.prototype.constructor = TextToggleButton;
TextToggleButton.superclass            = DomletCtr.prototype;
function TextToggleButton(domId, enabled, pressed, name, parent)
{
      ;
    if (domId) 
    {
        this.init(domId, enabled, pressed, name, parent);
    }
} 
TextToggleButton.prototype.init = function(domId, enabled, pressed, name, parent)
{
    TextToggleButton.superclass.init.call(this, domId, name, parent);
    ;
    this.domId = domId;
    this.addDomlet(new Domlet(
        this.domId,     
        this.name,      
        this.parent,    
        new Array(      
            'click',
            'mouseover',
            'mouseout',
            'mouseup',
            'mousedown'
        )
    ));
    this.state = {
        down : false,
        highlighted : false   
    };
    this.state.enabled = ((enabled == undefined) ? true : enabled);
    this.state.pressed = ((pressed == undefined) ? false : pressed);
    if (pressed) this.initialPressed = true;
    this.textColor = undefined;
    this.mouseoverTextColor = undefined;
    this.disabledTextColor = undefined;
    this.swapText = false;
    this.pressedText = null;
    this.unpressedText = null;
    this.activeCursor = this.domlets[this.name].getStyle('cursor');
    this.inactiveCursor = this.activeCursor;
    ;
} 
TextToggleButton.prototype.getEnableAction = function()
{
    return new ObjectMethodAction(this, "setEnabled", true);
}
TextToggleButton.prototype.getDisableAction = function()
{
    return new ObjectMethodAction(this, "setEnabled", false);
}
TextToggleButton.prototype.setPressedAction = function(action)
{
   ;
     this.pressedAction = action;
   ;
}
TextToggleButton.prototype.setUnpressedAction = function(action)
{
   ;
     this.unpressedAction = action;
   ;
}
TextToggleButton.prototype.getSetSilentPressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", true);
}
TextToggleButton.prototype.getSetSilentUnpressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", false);
}
TextToggleButton.prototype.getSetPressedAction = function()
{
    return new ObjectMethodAction(this, "setPressedWithAction", true);
}
TextToggleButton.prototype.getSetUnpressedAction = function()
{
    return new ObjectMethodAction(this, "setPressedWithAction", false);
}
TextToggleButton.prototype.setPressedWithAction = function(press)
{
    if (press)
        this.pressedAction.invoke();
    else
        this.unpressedAction.invoke();
    this.setPressed(press);
}
TextToggleButton.prototype.setEnabled = function(enabled)
{
    this.state.enabled = enabled;
    if(!enabled)
    {
        this.state.highlighted = false;
        this.state.down = false;
    }
    this.displayState();
}
TextToggleButton.prototype.setPressed = function(pressed, fromManager)
{
    ;
    this.state.pressed = pressed;
    if (fromManager)
    {
        if (this.state.pressed)
        {
            if (this.pressedAction)
            {
                this.pressedAction.invoke();
            }
        }
        else
        {
            if (this.unpressedAction)
            {
                this.unpressedAction.invoke();
            }    
        }
    }    
    this.displayState();
}
TextToggleButton.prototype.setSilentPressed = function(bPressed)
{
  ;
  this.state.pressed = bPressed;
  this.displayState();
}
TextToggleButton.prototype.setUnpressedColor = function(color)
{
    this.unpressedColor = color;
}
TextToggleButton.prototype.setPressedColor = function(color)
{
    this.pressedColor = color;
}
TextToggleButton.prototype.setPressedText = function(text)
{
  this.pressedText = text;
}
TextToggleButton.prototype.setUnpressedText = function(text)
{
  this.unpressedText = text;
}
TextToggleButton.prototype.showPressed = function()
{
    ;
    this.sTextColor = Browser.getComputedStyleById(this.domId, 'color');
    this.setFgColor(this.pressedColor);
    if(this.swapText)
    {
      this.oWidget.firstChild.style.display = 'inline';
      this.oWidget.lastChild.style.display = 'none';
    }
}
TextToggleButton.prototype.showUnPressed = function()
{
    ;
    if(!this.unpressedColor)
        this.setFgColor(this.sTextColor);
    else
        this.setFgColor(this.unpressedColor);
    if(this.swapText)
    {
      this.oWidget.lastChild.style.display = 'inline';
      this.oWidget.firstChild.style.display = 'none';
    }
}
TextToggleButton.prototype.setDisabledColor = function(color)
{
    this.disabledColor = color;
}
TextToggleButton.prototype.setDisabledPressedColor = function(color)
{
    this.disabledPressedColor = color;
}
TextToggleButton.prototype.setMouseoverColor = function(color)
{
    this.mouseoverColor = color;
}
TextToggleButton.prototype.setMouseoverPressedColor = function(color)
{
    this.mouseoverPressedColor = color;
}
TextToggleButton.prototype.displayState = function()
{
    if(this.state.enabled)
    {
        this.domlets[this.name].setStyle('cursor', this.activeCursor);
        if(this.state.pressed)
        {
            this.showPressed();
        }
        else
        {
            this.showUnPressed();
        }
    }
    else
    {
        this.domlets[this.name].setStyle('cursor', this.inactiveCursor);
        if(this.state.pressed)
        {
            ;
            this.sTextColor = this.oWidget.style.color;
            this.setFgColor(this.disabledPressedColor);
        }
        else
        {
            ;
            if(!this.disabledColor)
                this.setFgColor(this.sTextColor);
            else
                this.setFgColor(this.disabledColor);
        }
    }
}
TextToggleButton.prototype.setFgColor = function(color)
{
    if(color)
        Browser.changeStyleById(this.domId, "color", color);
}
TextToggleButton.prototype.eventFromChild = function(childName, eventType)
{
    ;
    if (this.state.enabled)
    {
        switch(eventType)
        {
            case "click" :
            {
                if (this.state.pressed)
                {
                    this.setPressed(false);
                    this.setFgColor(this.mouseoverColor);
                    if (this.buttonGroupManager)
                        this.buttonGroupManager.buttonUnpressed(this);
                    if (this.unpressedAction)
                    {
                        ;
                        this.unpressedAction.invoke();
                    }
                } 
                else
                {
                    this.setPressed(true);
                    this.setFgColor(this.mouseoverPressedColor);
                    if (this.buttonGroupManager)
                        this.buttonGroupManager.buttonPressed(this);
                    if (this.pressedAction)
                    {
                        ;
                        this.pressedAction.invoke();
                    }
                }
                break;
            }
            case "mouseover" :
            {
                ;
                if (this.state.pressed)
                {
                    ;
                    this.setFgColor(this.mouseoverPressedColor);
                }
                else
                {
                    ;
                    this.setFgColor(this.mouseoverColor);
                }
                break;
            }
            case "mouseout" :
            {
                ;
                if (this.state.pressed)
                {
                    ;
                    this.showPressed();
                }
                else
                {
                    ;
                    this.showUnPressed();
                }
                break;
            }
            case "mousedown" :
            {
                ;
                if (!this.state.pressed)
                {
                    ;
                    this.setFgColor(this.mouseoverPressedColor);
                }
                break;
            }
        }
    }
} 
TextToggleButton.prototype.showText = function()
{
	  var innerHtml =
	      '<span id="' + this.domId + '_pressed" style="position:absolute; display:inline;">' + this.pressedText + '</span>'
	  	+ '<span id="' + this.domId + '_unpressed" style="position:absolute; display:inline;">' + this.unpressedText + '</span>';
	  this.oWidget.innerHTML = innerHtml;
	  
	  var spanP = this.oWidget.firstChild;
	  var spanU = this.oWidget.lastChild;
	  
	  var spanPWidth;
	  var spanUWidth;
	  if(Browser.getId() == 'ie')
	  {
		  spanPWidth = spanP.clientWidth;
		  spanUWidth = spanU.clientWidth;
	  }
	  else
	  {
		  spanPWidth = Browser.getPixelComputedStyle(spanP, 'width');
		  spanUWidth = Browser.getPixelComputedStyle(spanU, 'width');
	  }
	  
	  if(spanPWidth > spanUWidth)
	  {
	    Browser.changePixelStyle(spanU, 'marginRight', spanPWidth-spanUWidth);
	  }
	  else
	  {
	    Browser.changePixelStyle(spanP, 'marginRight', spanUWidth-spanPWidth);
	  }
	  spanP.style.display = 'none';
	  spanU.style.display = 'inline';
	  spanP.style.position = 'relative';
	  spanU.style.position = 'relative';
	  this.swapText = true;
}
TextToggleButton.prototype.setActiveCursor = function(activeCursor)
{
  this.activeCursor = activeCursor;
}
TextToggleButton.prototype.setInactiveCursor = function(inactiveCursor)
{
  this.inactiveCursor = inactiveCursor;
}
TextToggleButton.prototype.start = function()
{
    if (this.initialPressed)
      this.setPressed(true);
    if(this.pressedText || this.unpressedText)
    {
      this.showText();
    }
    this.displayState();
}
TextToggleButton.prototype.setButtonGroupManager = function(buttonGroupManager)
{
    this.buttonGroupManager = buttonGroupManager;
}
