/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
TooltipWidget.prototype = new DomletCtr();
TooltipWidget.prototype.constructor = TooltipWidget;
TooltipWidget.superclass = DomletCtr.prototype;
var staticTooltipWidget = new Array;
TooltipWidget_getInstance = function(sId)
{
	var Instance = null;
	if (staticTooltipWidget[sId])
	{
		Instance = staticTooltipWidget[sId];
	}
	return Instance;
}
function TooltipWidget(sId, sTooltipWidgetDomId, sTemplateDomId, sText, sTooltipContentDomId)
{
	if (sId)
	{
		this.init(sId, sTooltipWidgetDomId, sTemplateDomId, sText, sTooltipContentDomId);
	}
}
TooltipWidget.prototype.init = function(sId, sTooltipWidgetDomId, sTemplateDomId, sText, sTooltipContentDomId)
{
	;
	this.sId = sId;
	this.sText = sText;
	this.XOffset = null;
	this.YOffset = null;
	this.nWidgetHeight = null;
	this.nHideTipTimeoutId = null;
	this.nShowTipTimeoutId = null;
	this.nShowTimeout = 1000;
	this.nHideTimeout = 4000;
	staticTooltipWidget[sId] = this;
	TooltipWidget.superclass.init.call(this, this.sTooltipWidgetDomId, this.sId, this);
	this.oTooltipWidget = document.getElementById(sTooltipWidgetDomId);
	this.sTooltipWidgetDomId = sTooltipWidgetDomId;
	if (this.oTooltipWidget == null)
	{
		;
	}
	this.oTooltipContent = document.getElementById(sTooltipContentDomId);
	this.sTooltipContentDomId = sTooltipContentDomId;
	if (this.oTooltipContent == null)
	{
		;
	}
	this.oTemplate = document.getElementById(sTemplateDomId);
	this.sTemplateDomId = sTemplateDomId;
	if (this.oTemplate == null)
	{
		;
	}
	else
	{
		this.addDomlet(new Domlet(
				this.sTooltipWidgetDomId, 
				this.sTooltipWidgetDomId, 
				this, 
				new Array('mouseover', 'mouseout', 'mousemove')))	 
	}
	var pAbsPos = new Point(0, 0);
	this.oTemplate.style.position = 'absolute';
	Browser.changePixelStyle(this.oTemplate, 'top', 0);
	Browser.changePixelStyle(this.oTemplate, 'left', 0);
	Browser.getAbsPos(this.oTemplate, pAbsPos);
	this.XOffset -= pAbsPos.x;
	this.YOffset -= pAbsPos.y;
}
TooltipWidget.prototype.getId = function()
{
	;
	return this.sId;
}
TooltipWidget.prototype.setShowTimeout = function(nShowTimeout)
{
	;
	this.nShowTimeout = nShowTimeout;
}
TooltipWidget.prototype.setPosOffset = function(nXOffset, nYOffset)
{
	;
	this.XOffset += nXOffset;
	this.YOffset += nYOffset;
}
TooltipWidget.prototype.setHideTimeout = function(nHideTimeout)
{
	;
	this.nHideTimeout = nHideTimeout;
}
TooltipWidget.prototype.eventFromChild = function(childName, eventType, event)
{
	////;
	var domlet = this.domlets[childName];
	switch (eventType)
			{
		case "mouseover" :
			;
			this.mouseoverHandler(domlet, event);
			break;
		case "mousemove" :
			;
			this.mousemoveHandler(domlet, event);
			break;
		case "mouseout" :
			;
			this.mouseoutHandler(domlet, event);
			break;
	}
}
TooltipWidget.prototype.mouseoverHandler = function(domlet, event)
{
	;
	if (this.sText)
	{
		if (this.oTooltipContent)
		{
			this.oTooltipContent.innerHTML = this.sText;
		}
		else
		{
			this.oTemplate.innerHTML = this.sText;
		}
	}
	var templateHeight = parseInt(Browser.getComputedStyleById(this.sTemplateDomId, "height"));
	var scrollTop = parseInt(Browser.getBodyScrollTop());
	Browser.changePixelStyle(this.oTemplate, 'top', event.clientY + this.YOffset - (templateHeight?templateHeight:0) + (scrollTop?scrollTop:0));
	Browser.changePixelStyle(this.oTemplate, 'left', event.clientX + this.XOffset + parseInt(Browser.getBodyScrollLeft()));
	this.nShowTipTimeoutId = window.setTimeout('TooltipWidget_getInstance(\'' + this.sId + '\').showTooltip(' + event.clientX + ', ' + event.clientY + ');', this.nShowTimeout);
	if (this.nHideTipTimeoutId)
	{
		clearTimeout(this.nHideTipTimeoutId);
		this.nHideTipTimeoutId = null;
	}
}
TooltipWidget.prototype.showTooltip = function()
{
	;
	if (this.nHideTipTimeoutId)
	{
		clearTimeout(this.nHideTipTimeoutId);
		this.nHideTipTimeoutId = null;
	}
	if (this.nShowTipTimeoutId)
	{
		clearTimeout(this.nShowTipTimeoutId);
		this.nShowTipTimeoutId = null;
	}
	if (this.oTemplate.style.position != 'absolute')
	{
		this.oTemplate.style.position = 'absolute';
	}
	this.oTemplate.style.visibility = 'visible';
	if (this.nHideTimeout)
	{
		this.nHideTipTimeoutId = window.setTimeout('TooltipWidget_getInstance(\'' + this.sId + '\').mouseoutHandler();', this.nHideTimeout);
	}
}
TooltipWidget.prototype.mousemoveHandler = function(domlet, event)
{
	;
	var templateHeight = parseInt(Browser.getComputedStyleById(this.sTemplateDomId, "height"));
	var scrollTop = parseInt(Browser.getBodyScrollTop());
	Browser.changePixelStyle(this.oTemplate, 'top', event.clientY + this.YOffset - (templateHeight?templateHeight:0) + (scrollTop?scrollTop:0));
	Browser.changePixelStyle(this.oTemplate, 'left', event.clientX + this.XOffset + parseInt(Browser.getBodyScrollLeft()));
}
TooltipWidget.prototype.mouseoutHandler = function(domlet, event)
{
	;
	if (this.nHideTipTimeoutId)
	{
		clearTimeout(this.nHideTipTimeoutId);
		this.nHideTipTimeoutId = null;
	}
	if (this.nShowTipTimeoutId)
	{
		clearTimeout(this.nShowTipTimeoutId);
		this.nShowTipTimeoutId = null;
	}
	this.oTemplate.style.visibility = 'hidden';
}
TooltipWidget.prototype.getChangeTooltipTextAction = function(tooltiptext)
{
    return new ObjectMethodAction(this, "changeTooltipText", tooltiptext);
}
TooltipWidget.prototype.changeTooltipText= function(tooltiptext)
{
    this.sText = tooltiptext;
}
