/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
UniversalPushButton.prototype = new DomletCtr();
UniversalPushButton.prototype.constructor = UniversalPushButton;
UniversalPushButton.superclass = DomletCtr.prototype;
function UniversalPushButton( domId, enabled, name, parent )
{
  ;
  if( domId ) 
  {
    this.init(domId, enabled, name, parent);
  }
}
UniversalPushButton.prototype.init = function( domId, enabled, name, parent )
{
  UniversalPushButton.superclass.init.call(this, domId, name, parent);
  ;
  this.addDomlet(new Domlet(
          this.domId, 
          this.name, 
          this.parent, 
          new Array(
          'mouseout',
          'mouseover',
          'mousedown',
          'mouseup',
          'click'
          )
          ));
  this.state = {
    pressed : false,       
    highlighted : false   
  };
  this.state.enabled = ((enabled == undefined) ? true : enabled);
  this.state.suspend = false;
  this.broker = new Broker('pushButtonBroker');
  ;
} 
UniversalPushButton.prototype.registerBroker = function( broker )
{
  this.broker = broker;
}
UniversalPushButton.prototype.addNormalAction = function( action )
{
  this.broker.registerAction("normalAction", action);
}
UniversalPushButton.prototype.addMouseoverNormalAction = function( action )
{
  this.broker.registerAction("mouseoverNormalAction", action);
}
UniversalPushButton.prototype.addPressedAction = function( action )
{
  this.broker.registerAction("pressedAction", action);
}
UniversalPushButton.prototype.addMouseoverPressedAction = function( action )
{
  this.broker.registerAction("mouseoverPressedAction", action);
}
UniversalPushButton.prototype.addDisabledAction = function( action )
{
  this.broker.registerAction("disabledAction", action);
}
UniversalPushButton.prototype.addDisabledPressedAction = function( action )
{
  this.broker.registerAction("disabledPressedAction", action);
}
UniversalPushButton.prototype.addEnabledAction = function( action )
{
  this.broker.registerAction("enabledAction", action);
}
UniversalPushButton.prototype.addEnabledPressedAction = function( action )
{
  this.broker.registerAction("enabledPressedAction", action);
}
UniversalPushButton.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, "setEnabled", true);
}
UniversalPushButton.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, "setEnabled", false);
}
UniversalPushButton.prototype.setPressedAction = function( action )
{
  this.pressedAction = action;
}
UniversalPushButton.prototype.setDownAction = function( action )
{
  this.downAction = action;
}
UniversalPushButton.prototype.setUpAction = function( action )
{
  this.upAction = action;
}
UniversalPushButton.prototype.setEnabled = function( enabled )
{
  this.state.enabled = enabled;
  if( this.state.enabled )
  {
    if( this.state.pressed ) this.broker.getMessage("enabledPressedAction");
    else this.broker.getMessage("enabledAction");
  }
  else
  {
    this.resetMouseStatus();
    if( this.state.pressed ) this.broker.getMessage("disabledPressedAction");
    else this.broker.getMessage("disabledAction");
  }
}
UniversalPushButton.prototype.setSuspend = function( suspend )
{
  this.state.suspend = suspend;
}
UniversalPushButton.prototype.resetMouseStatus = function()
{
  this.state.highlighted = false;
  this.state.pressed = false;
  this.broker.getMessage("normalAction");
}
UniversalPushButton.prototype.eventFromChild = function( childName, eventType )
{
  ;
  if( this.state.enabled && (this.broker != null) && !this.state.suspend )
  {
    switch( eventType )
            {
      case "mouseover" :
        this.state.highlighted = true;
        if( this.state.pressed ) this.broker.getMessage("mouseoverPressedAction");
        else this.broker.getMessage("mouseoverNormalAction");
        break;
      case "mouseout" :
        if( this.state.pressed == true )
        {
          this.state.pressed = false;
          this.broker.getMessage("mouseoverNormalAction");
          if( this.upAction )
          {
            ;
            this.upAction.invoke();
          }
        }
        this.resetMouseStatus();
        break;
      case "mousedown" :
        this.state.pressed = true;
        this.broker.getMessage("mouseoverPressedAction");
        if( this.downAction )
        {
          ;
          this.downAction.invoke();
        }
        break;
      case "mouseup" :
        this.state.pressed = false;
        this.broker.getMessage("mouseoverNormalAction");
        if( this.upAction )
        {
          ;
          this.upAction.invoke();
        }
        break;
      case "click" :
        this.state.pressed = false;
        if( this.buttonGroupManager )
          this.buttonGroupManager.buttonPushed(this);
        if( this.pressedAction )
        {
          ;
          this.pressedAction.invoke();
        }
        break;
    }
  }
} 
UniversalPushButton.prototype.getSetPressedAction = function()
{
  return new ObjectMethodAction(this, "setPressed", true);
}
UniversalPushButton.prototype.setPressed = function( bPressed )
{
  ;
  if( bPressed )
  {
    if( this.buttonGroupManager )
      this.buttonGroupManager.buttonPushed(this);
    if( this.pressedAction )
    {
      this.pressedAction.invoke();
    }
  }
}
UniversalPushButton.prototype.setButtonGroupManager = function( buttonGroupManager )
{
  this.buttonGroupManager = buttonGroupManager;
}
