/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function UserInteractionController(sId, exerciseBroker, tipBroker, workItemBroker)
{
  this.init(sId, exerciseBroker, tipBroker, workItemBroker);
}
UserInteractionController.prototype.init = function(sId, exerciseBroker, tipBroker, workItemBroker)
{
  ;
  this.sId = sId;
  this.exerciseBroker = exerciseBroker;
  this.workItemBroker = workItemBroker;
  this.tipBroker = tipBroker;
  this.bSoluted = false;
  this.bStopped = false;
  this.bInteractionAllowed = true;
  this.oBroker = null;
  if(this.exerciseBroker)
  {
    this.exerciseBroker.addWorkStoppedHandle(this.getSetStoppedAction());
    this.exerciseBroker.addResetHandle(this.getResetStoppedAction());
    this.exerciseBroker.addResetHandle(this.getResetSolutedAction());
  }
  if(this.tipBroker)
  {
    this.tipBroker.addShowSolutionHandle(this.getSetSolutedAction());
    this.tipBroker.addHideSolutionHandle(this.getResetSolutedAction());
  }
  if(this.workItemBroker)
  {
    this.workItemBroker.addWorkStoppedHandle(this.getSetStoppedAction());
  }
}
UserInteractionController.prototype.setUserInteractionBroker = function(userInteractionBroker)
{
  this.oBroker = userInteractionBroker;
}
UserInteractionController.prototype.getSetSolutedAction = function()
{
  return new ObjectMethodAction(this, "setSoluted", true);
}
UserInteractionController.prototype.getResetSolutedAction = function()
{
  return new ObjectMethodAction(this, "setSoluted", false);
}
UserInteractionController.prototype.getSetStoppedAction = function()
{
  return new ObjectMethodAction(this, "setStopped", true);
}
UserInteractionController.prototype.getResetStoppedAction = function()
{
  return new ObjectMethodAction(this, "setStopped", false);
}
UserInteractionController.prototype.setSoluted = function(bSoluted)
{
  this.bSoluted = bSoluted;
  this.checkState();
}
UserInteractionController.prototype.setStopped = function(bStopped)
{
  this.bStopped = bStopped;
  this.checkState();
}
UserInteractionController.prototype.checkState = function()
{
  if(this.bSoluted || this.bStopped)
  {
    this.forbidInteraction();
  }
  else
  {
    this.allowInteraction();
  }
}
UserInteractionController.prototype.allowInteraction = function()
{
  if(!this.bInteractionAllowed)
  {
    this.bInteractionAllowed = true;
    if(this.oBroker)
    {
      this.oBroker.allowInteraction();
    }
  }
}
UserInteractionController.prototype.forbidInteraction = function()
{
  if(this.bInteractionAllowed)
  {
    this.bInteractionAllowed = false;
    if(this.oBroker)
    {
      this.oBroker.forbidInteraction();
    }
  }
}
