/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>ConfirmDialogBroker</DEPENDS>
    <DEPENDS>Action</DEPENDS>
</DEPENDENCIES>
*/
ConfirmDialog.prototype = new DomletCtr();
ConfirmDialog.prototype.constructor = ConfirmDialog;
ConfirmDialog.superclass = DomletCtr.prototype;
function ConfirmDialog(sId, domId, dialogId)
{
	if (!sId) sId = "ConfirmDialog";
	this.init(domId);
	this.dialogBroker = undefined;
	this.dialogId = dialogId;
}
ConfirmDialog.prototype.init = function(domId)
{
	;
	ConfirmDialog.superclass.init.call(this, domId);
}
ConfirmDialog.prototype.setConfirmDialogBroker = function(broker)
{
	this.dialogBroker = broker;
	this.dialogBroker.addBeforeYesNoHandle(this.getShowAgainStoreAction());
	this.dialogBroker.addYesHandle(this.getHideAction());
	this.dialogBroker.addNoHandle(this.getHideAction());
	this.dialogBroker.addAbortHandle(this.getHideAction());
}
ConfirmDialog.prototype.setConfirmDialogVisibilityBroker = function(broker)
{
	this.dialogVisibilityBroker = broker;
	this.dialogVisibilityBroker.addDoNotShowDialogAgainHandle(this.getDoNotShowDialogAgainAction());
	this.dialogVisibilityBroker.addShowDialogAgainHandle(this.getShowDialogAgainAction());
}
ConfirmDialog.prototype.setToggle = function(toggle)
{
	this.toggle = toggle;
}
ConfirmDialog.prototype.show = function(externalDialogBroker)
{
	;
	if (this.dialogBroker)
		this.dialogBroker.setExternalBroker(externalDialogBroker);
	else
		;
}
ConfirmDialog.prototype.hide = function()
{
	;
	if (this.dialogBroker)
		this.dialogBroker.removeExternalBroker();
	else
		;
}
ConfirmDialog.prototype.getShowAction = function()
{
	return new ObjectMethodAction(this, 'show');
}
ConfirmDialog.prototype.getHideAction = function()
{
	return new ObjectMethodAction(this, 'hide');
}
ConfirmDialog.prototype.getDoNotShowDialogAgainAction = function()
{
	return new ObjectMethodAction(this, 'doNotShowDialogAgain');
}
ConfirmDialog.prototype.getShowDialogAgainAction = function()
{
	return new ObjectMethodAction(this, 'showDialogAgain');
}
ConfirmDialog.prototype.getShowAgainStoreAction = function()
{
	return new ObjectMethodAction(this, 'showAgainStore');
}
ConfirmDialog.prototype.doNotShowDialogAgain = function()
{
	;
	this.toggle.setOn();
}
ConfirmDialog.prototype.showDialogAgain = function()
{
	;
	this.toggle.setOff();
}
ConfirmDialog.prototype.showAgainStore = function()
{
	;
}
