/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>ValueMap</DEPENDS>
    <DEPENDS>Action</DEPENDS>
</DEPENDENCIES>
*/
FormBroker.prototype             = new Broker();
FormBroker.prototype.constructor = FormBroker;
FormBroker.superclass            = Broker.prototype;
function FormBroker(sId)
{
  if (sId) { this.init(sId); }
}
FormBroker.prototype.init = function(sId)
{
  ;   
  this.sId = sId;
  this.nValueMap = 0;  
  FormBroker.superclass.init.call(this, sId);
}
FormBroker.prototype.doSend = function()
{
  this.getMessage('send');
}
FormBroker.prototype.addSendHandle = function(action)
{
  this.registerAction('send', action);
}
FormBroker.prototype.getSendAction = function()
{
  return new ObjectMethodAction(this, 'send');
}
FormBroker.prototype.send = function()
{
  ;
  this.doSend();
}
FormBroker.prototype.doSet = function(ValueMap)
{
  var paramArray = new Array();
  if(ValueMap)
  {
    paramArray.push(ValueMap);
  }
  this.getMessage('set', paramArray);
}
FormBroker.prototype.addSetHandle = function(action)
{
  this.registerAction('set', action);
}
FormBroker.prototype.getSetAction = function(ValueMap)
{
  return new ObjectMethodAction(this, 'set', ValueMap);
}
FormBroker.prototype.set = function(ValueMap)
{
  ;
  this.doSet(ValueMap);
}
FormBroker.prototype.doSetKeyVal = function(Key, Value, bSend)
{
  var paramArray = new Array();
  var oValueMap = new ValueMap(this.sId + '_DynValuaMap_' + Key + '_' + Value + '_' + this.nValueMap++, bSend);
  oValueMap.addKeyValue(Key, Value);
  paramArray.push(oValueMap);
  this.getMessage('set', paramArray);
}
FormBroker.prototype.addSetKeyValHandle = function(action)
{
  this.registerAction('set', action);
}
FormBroker.prototype.getSetKeyValAction = function(Key, Value, bSend)
{
  return new ObjectMethodAction(this, 'setKeyVal', Key, Value, bSend);
}
FormBroker.prototype.setKeyVal = function(Key, Value, bSend)
{
  ;
  this.doSetKeyVal(Key, Value, bSend);
}
FormBroker.prototype.doSetKey = function(Key, Value, bSend)
{
  var paramArray = new Array();
  var oValueMap = new ValueMap(this.sId + '_DynValuaMap_' + Key + '_' + Value + '_' + this.nValueMap++, bSend);
  oValueMap.addKeyValue(Key, Value);
  paramArray.push(oValueMap);
  this.getMessage('set', paramArray);
}
FormBroker.prototype.addSetKeyHandle = function(action)
{
  this.registerAction('set', action);
}
FormBroker.prototype.getSetKeyAction = function(Key, bSend)
{
  return new FormBrokerCharSendAction(this, 'setKey', Key, bSend);
}
FormBroker.prototype.setKey = function(Key, Value, bSend)
{
  ;
  this.doSetKey(Key, Value, bSend);
}
FormBroker.prototype.doDeactivateSubmitAction = function()
{
  this.getMessage('deactivateSubmitAction');
}
FormBroker.prototype.addDeactivateSubmitHandle = function(action)
{
  this.registerAction('deactivateSubmitAction', action);
}
FormBroker.prototype.getDeactivateSubmitAction = function()
{
  return new ObjectMethodAction(this, 'deactivateSubmitAction');
}
FormBroker.prototype.deactivateSubmitAction = function()
{
  ;
  this.doDeactivateSubmitAction();
}
FormBroker.prototype.doActivateSubmitAction = function()
{
  this.getMessage('activateSubmitAction');
}
FormBroker.prototype.addActivateSubmitHandle = function(action)
{
  this.registerAction('activateSubmitAction', action);
}
FormBroker.prototype.getActivateSubmitAction = function()
{
  return new ObjectMethodAction(this, 'activateSubmitAction');
}
FormBroker.prototype.activateSubmitAction = function()
{
  ;
  this.doActivateSubmitAction();
}
function FormBrokerCharSendAction(objectName, methodname, key, bSend)
{
    this.objectName= objectName;
    this.methodname = methodname;
    this.key = key;
    this.bSend = bSend;
}
FormBrokerCharSendAction.prototype.invoke = function(value)
{
    return this.objectName[this.methodname](this.key, value, this.bSend);
}
