/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
</DEPENDENCIES>
*/
function WidgetMouseEventHandler( sId, sWidgetDomId )
{
	if( sId )
	{
		this.init(sId, sWidgetDomId);
	}
}
WidgetMouseEventHandler.prototype.init = function( sId, sWidgetDomId )
{
	;
	this.sId = sId;
	this.widgetDomId = sWidgetDomId;
	this.nWidget = Browser.getElementById(this.widgetDomId);
	
	this.listenToMouseDownEvent = false;
	this.aDownHandles = new Array();
	this.listenToMouseUpEvent = false;
	this.aUpHandles = new Array();
	this.listenToMouseClickEvent = false;
	this.aClickHandles = new Array();
	this.listenToMouseDblClickEvent = false;
	this.aDblClickHandles = new Array();
	this.listenToMouseOverEvent = false;
	this.aOverHandles = new Array();
	this.listenToMouseOutEvent = false;
	this.aOutHandles = new Array();
}
WidgetMouseEventHandler.prototype.start = function()
{
	if( this.listenToMouseDownEvent )
	{
		;
		WidgetMouseEventHandler.createMouseDownEventHandler(this);
		Browser.addEventListenerToDomNode(this.nWidget, Browser.eventNames.MOUSEDOWN, this.mouseDownHandler);
	}
	if( this.listenToMouseUpEvent )
	{
		;
		WidgetMouseEventHandler.createMouseUpEventHandler(this);
		Browser.addEventListenerToDomNode(this.nWidget, Browser.eventNames.MOUSEUP, this.mouseUpHandler);
	}
	if( this.listenToMouseClickEvent )
	{
		;
		WidgetMouseEventHandler.createMouseClickEventHandler(this);
		Browser.addEventListenerToDomNode(this.nWidget, Browser.eventNames.CLICK, this.mouseClickHandler);
	}
	if( this.listenToMouseDblClickEvent )
	{
		;
		WidgetMouseEventHandler.createMouseDblClickEventHandler(this);
		Browser.addEventListenerToDomNode(this.nWidget, Browser.eventNames.DBLCLICK, this.mouseDblClickHandler);
	}
	if( this.listenToMouseOverEvent )
	{
		;
		WidgetMouseEventHandler.createMouseOverEventHandler(this);
		Browser.addEventListenerToDomNode(this.nWidget, Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
	}
	if( this.listenToMouseOutEvent )
	{
		;
		WidgetMouseEventHandler.createMouseOutEventHandler(this);
		Browser.addEventListenerToDomNode(this.nWidget, Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
	}
}
WidgetMouseEventHandler.prototype.getId = function()
{
	return this.sId;
}
WidgetMouseEventHandler.createMouseDownEventHandler = function( me )
{
	me.mouseDownHandler = function( event )
	{
		;
		if( !event )
			event = window.event;
		me.doMouseDown(event);
	}
}
WidgetMouseEventHandler.createMouseUpEventHandler = function( me )
{
	me.mouseUpHandler = function( event )
	{
		;
		if( !event )
			event = window.event;
		me.doMouseUp(event);
	}
}
WidgetMouseEventHandler.createMouseClickEventHandler = function( me )
{
	me.mouseClickHandler = function( event )
	{
		;
		if( !event )
			event = window.event;
		me.doMouseClick(event);
	}
}
WidgetMouseEventHandler.createMouseDblClickEventHandler = function( me )
{
	me.mouseDblClickHandler = function( event )
	{
		;
		if( !event )
			event = window.event;
		me.doMouseDblClick(event);
	}
}
WidgetMouseEventHandler.createMouseOverEventHandler = function( me )
{
	me.mouseOverHandler = function( event )
	{
		;
		if( !event )
			event = window.event;
		me.doMouseOver(event);
	}
}
WidgetMouseEventHandler.createMouseOutEventHandler = function( me )
{
	me.mouseOutHandler = function( event )
	{
		;
		if( !event )
			event = window.event;
		me.doMouseOut(event);
	}
}
WidgetMouseEventHandler.prototype.doMouseDown = function( event )
{
	WidgetMouseEventHandler.notifyListeners(this.aDownHandles);
}
WidgetMouseEventHandler.prototype.getMouseDownAction = function()
{
	return new ObjectMethodAction(this, "doMouseDown");
}
WidgetMouseEventHandler.prototype.addMouseDownHandle = function( action )
{
	if( action )
	{
		this.aDownHandles.push(action);
		this.listenToMouseDownEvent = true;
  }
}
WidgetMouseEventHandler.prototype.doMouseUp = function( event )
{
	WidgetMouseEventHandler.notifyListeners(this.aUpHandles);
}
WidgetMouseEventHandler.prototype.getMouseUpAction = function()
{
	return new ObjectMethodAction(this, "doMouseUp");
}
WidgetMouseEventHandler.prototype.addMouseUpHandle = function( action )
{
	if( action )
	{
		this.aUpHandles.push(action);
		this.listenToMouseUpEvent = true;
  }
}
WidgetMouseEventHandler.prototype.doMouseClick = function( event )
{
	WidgetMouseEventHandler.notifyListeners(this.aClickHandles);
}
WidgetMouseEventHandler.prototype.getMouseClickAction = function()
{
	return new ObjectMethodAction(this, "doMouseClick");
}
WidgetMouseEventHandler.prototype.addMouseClickHandle = function( action )
{
	if( action )
	{
		this.aClickHandles.push(action);
		this.listenToMouseClickEvent = true;
  }
}
WidgetMouseEventHandler.prototype.doMouseDblClick = function( event )
{
	WidgetMouseEventHandler.notifyListeners(this.aDblClickHandles);
}
WidgetMouseEventHandler.prototype.getMouseDblClickAction = function()
{
	return new ObjectMethodAction(this, "doMouseDblClick");
}
WidgetMouseEventHandler.prototype.addMouseDblClickHandle = function( action )
{
	if( action )
	{
		this.aDblClickHandles.push(action);
		this.listenToMouseDblClickEvent = true;
  }
}
WidgetMouseEventHandler.prototype.doMouseOver = function( event )
{
	WidgetMouseEventHandler.notifyListeners(this.aOverHandles);
}
WidgetMouseEventHandler.prototype.getMouseOverAction = function()
{
	return new ObjectMethodAction(this, "doMouseOver");
}
WidgetMouseEventHandler.prototype.addMouseOverHandle = function( action )
{
	if( action )
	{
		this.aOverHandles.push(action);
		this.listenToMouseOverEvent = true;
  }
}
WidgetMouseEventHandler.prototype.doMouseOut = function( event )
{
	WidgetMouseEventHandler.notifyListeners(this.aOutHandles);
}
WidgetMouseEventHandler.prototype.getMouseOutAction = function()
{
	return new ObjectMethodAction(this, "doMouseOut");
}
WidgetMouseEventHandler.prototype.addMouseOutHandle = function( action )
{
	if( action )
	{
		this.aOutHandles.push(action);
		this.listenToMouseOutEvent = true;
  }
}
WidgetMouseEventHandler.notifyListeners = function( handles )
{
	for( var i = 0; i < handles.length; i++ )
	{
		handles[i].invoke();
	}
}
