/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Dragable</DEPENDS>
</DEPENDENCIES>
*/
MatcherDragable.prototype             = new Dragable();
MatcherDragable.prototype.constructor = MatcherDragable;
MatcherDragable.superclass            = Dragable.prototype;
function MatcherDragable(sId, sWidgetDomId, nHotSpotX, nHotSpotY)
{
  if (sId) { this.init(sId, sWidgetDomId, nHotSpotX, nHotSpotY) }
}
MatcherDragable.prototype.init = function(sId, sWidgetDomId, nHotSpotX, nHotSpotY)
{
  ;
  MatcherDragable.superclass.init.call(this, sId, sWidgetDomId, nHotSpotX, nHotSpotY);
  this.viewManager = null;
  this.optionItem = null;
  this.showUnassignedAction = null;
  this.showAssignedAction = null;
  this.showTipAssignedAction = null;
  this.showCorrectAction = null;
  this.showWrongAction = null;
  this.showSolutionAction = null;
  this.hideSolutionAction = null;
}
MatcherDragable.prototype.setOptionItem = function(optionItem)
{
  ;
  this.optionItem = optionItem;
}
MatcherDragable.prototype.setByModel = function(model)
{
  ;
  var sCurrentValue = model.getCurrentValue();
  if (sCurrentValue != '')
  {
    this.dropTarget = this.dragnDropManager.getDropTargetByModelId(sCurrentValue);
    this.dropTarget.snap(this);
    var valueItem = this.dropTarget.getValueItem();
    if (valueItem.getOrigin() == 'user')
    {
      if (this.showAssignedAction) { this.showAssignedAction.invoke(); }
    }
    else if (valueItem.getOrigin() == 'system')
    {
      if (this.showTipAssignedAction) { this.showTipAssignedAction.invoke(); }
    }
    else
    {
      ;
      if (this.showUnassignedAction) { this.showUnassignedAction.invoke(); }
    }
  }
  else
  {
    if (this.showUnassignedAction) { this.showUnassignedAction.invoke(); }
    this.moveToHomePosition();
    this.dropTarget = null;
  }
}
MatcherDragable.prototype.setBySolution = function(model)
{
  ;
  var solution = this.optionItem.getSolution();
  if (solution == '')
  {
    if (this.showUnassignedAction) { this.showUnassignedAction.invoke(); }
    this.moveToHomePosition();
  }
  else
  {
    if (this.showAssignedAction) { this.showAssignedAction.invoke(); }
    this.dropTarget = this.dragnDropManager.getDropTargetByModelId(solution);
    this.dropTarget.snap(this);
  }
}
MatcherDragable.prototype.changed = function(model)
{
  ;
  this.setByModel(model);
}
MatcherDragable.prototype.registerViewManager = function(viewManager)
{
  ;
  this.viewManager = viewManager;
}
MatcherDragable.prototype.evaluate = function()
{
  ;
}
MatcherDragable.prototype.showSolution = function()
{
  ;
  this.setBySolution(this.optionItem);
}
MatcherDragable.prototype.hideSolution = function()
{
  ;
  this.setByModel(this.optionItem);
}
MatcherDragable.prototype.setShowAssignedAction = function(action)
{
  ;
  this.showAssignedAction = action;
}
MatcherDragable.prototype.setShowUnassignedAction = function(action)
{
  ;
  this.showUnassignedAction = action;
}
MatcherDragable.prototype.setShowTipAssignedAction = function(action)
{
  ;
  this.showTipAssignedAction = action;
}
MatcherDragable.prototype.setShowCorrectAction = function(action)
{
  ;
  this.showCorrectAction = action;
}
MatcherDragable.prototype.setShowWrongAction = function(action)
{
  ;
  this.showWrongAction = action;
}
MatcherDragable.prototype.setShowSolutionAction = function(action)
{
  ;
  this.showSolutionAction = action;
}
MatcherDragable.prototype.setHideSolutionAction = function(action)
{
  ;
  this.hideSolutionAction = action;
}
