/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function Product(sId, productId, loaded, productName, manufacturer, minprice, maxprice, curreny, iconURL)
{
	if (sId)
	{
		this.init(sId, productId, loaded, productName, manufacturer, minprice, maxprice, curreny, iconURL);
	}
}
Product.prototype.init = function(sId, productId, loaded, productName, manufacturer, minprice, maxprice, curreny, iconURL)
{
	this.sId = sId;
	this.productId = productId;
	this.loaded = loaded;
	this.productName = productName;
	this.manufacturer = manufacturer;
	this.minprice = minprice;
	this.maxprice = maxprice;
	this.curreny = curreny;
	this.iconURL = iconURL;
	this.buildPriceRange();
}
Product.prototype.buildPriceRange = function()
{
	if (this.minprice == null || this.minprice == undefined)
	{
		this.pricerange = null;
		return;
	}
	if (this.maxprice == null || this.maxprice == undefined)
	{
		this.pricerange = null;
		return;
	}
	if (this.curreny == null || this.curreny == undefined)
	{
		this.curreny = null;
		return;
	}
	this.pricerange = this.minprice + ' - ' + this.maxprice + ' ' + this.curreny;
}
Product.prototype.getId = function()
{
	return this.sId;
}
Product.prototype.isLoaded = function()
{
	return this.loaded;
}
Product.prototype.setLoaded = function()
{
	this.loaded = true;
}
Product.prototype.setProductInfo = function(productInfo)
{
	this.loaded = true;
	this.productId = productInfo.getProductId();
	this.productName = productInfo.getProductName();
	this.manufacturer = productInfo.getManufacturer();
	this.minprice = productInfo.getMinPrice();
	this.maxprice = productInfo.getMaxPrice();
	this.curreny = productInfo.getCurrency();
	this.iconURL = productInfo.getIconURL();
	this.buildPriceRange();
}
Product.prototype.getProductId = function()
{
	return this.productId;
}
Product.prototype.hasData = function()
{
	return (this.data != null);
}
Product.prototype.getData = function()
{
	return this.data;
}
Product.prototype.setData = function(data)
{
	this.data = data;
}
Product.prototype.getProductName = function()
{
	return this.productName;
}
Product.prototype.getManufacturer = function()
{
	return this.manufacturer;
}
Product.prototype.getMinPrice = function()
{
	return this.minprice;
}
Product.prototype.getMaxPrice = function()
{
	return this.maxprice;
}
Product.prototype.getCurrency = function()
{
	return this.curreny;
}
Product.prototype.getIconURL = function()
{
	return this.iconURL;
}
