/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function ProductFilter(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
ProductFilter.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.filters = new Array();
	this.sorter = new Array();
	this.actualMethodCallId = null;
	this.methodCallCounter = 0;
	this.reseting = false;
}
ProductFilter.prototype.getId = function()
{
	return this.sId;
}
ProductFilter.prototype.start = function()
{
	;
}
ProductFilter.prototype.setManager = function(manager)
{
	;
	this.manager = manager;
}
ProductFilter.prototype.registerFilter = function(filter)
{
	;
	this.filters[filter.getId()] = filter;
	filter.setManager(this);
}
ProductFilter.prototype.registerSorter = function(sorter)
{
	;
	this.sorter[sorter.getId()] = sorter;
	sorter.setManager(this);
}
ProductFilter.prototype.isAutoCommit = function()
{
	
	return true;
}
ProductFilter.prototype.process = function()
{
	;
	if (this.reseting == false)
	{
		var command = '';
		var valuesBySubmitParameter = new Array();
		for (var id in this.filters)
		{
			var filter = this.filters[id];
			if (filter.isActive())
			{
				var submitParam = "&" + filter.getSubmitParam() + "=";
				var filtervalue = filter.getCommandValues();
				for (var i = 0; i < filtervalue.length; i++)
				{
					command += submitParam + filtervalue[i].getValueId();
				}
			}
		}
		for (var id in this.sorter)
		{
			var sorter = this.sorter[id];
			if (sorter.isActive())
			{
				var submitParam = "&sorter=";
				var sortervalue = sorter.getCommandValues();
				for (var i = 0; i < sortervalue.length; i++)
				{
					command += submitParam + encodeURIComponent(sortervalue[i].getValueId());
					break;
				}
			}
		}
		;
		
		this.actualMethodCallId = this.getId() + "_filtercall_" + this.methodCallCounter;
		var callId = this.getId() + "_filtercall_" + this.methodCallCounter;
		this.methodCallCounter++;
		DynamicDataLoader.instance.loadFilterData(new ProductFilterMethodCall(callId, this), this.manager.getManagerName(), command);
	}
}
ProductFilter.prototype.getResetFilterAction = function()
{
	return new ObjectMethodAction(this, "reset");
}
ProductFilter.prototype.reset = function()
{
	;
	this.reseting = true;
	for (var id in this.filters)
	{
		var filter = this.filters[id];
		filter.reset();
	}
	for (var id in this.sorter)
	{
		var sor = this.sorter[id];
		sor.reset();
	}
	this.reseting = false;
	this.process();
}
ProductFilter.prototype.isValidMethodCall = function(methodCallId)
{
	if (this.actualMethodCallId == methodCallId)
		return true;
	return false;
}
function ProductFilterMethodCall(id, productFilter)
{
	this.id = id;
	this.productFilter = productFilter;
}
ProductFilterMethodCall.prototype.started = function()
{
	this.productFilter.manager.fireAboutToLoadModelData();
}
ProductFilterMethodCall.prototype.dataLoaded = function(productids)
{
	;
	if (this.filterResult == null)
		this.filterResult = new Array();
	this.filterResult = this.filterResult.concat(productids);
}
ProductFilterMethodCall.prototype.commit = function()
{
	;
	if (this.productFilter.isValidMethodCall(this.id))
	{
		this.productFilter.manager.filterByProductIds(this.filterResult);
		if (this.productFilter.isValidMethodCall(this.id))
			this.productFilter.manager.fireModelDataLoaded(this.filterResult.length);
	}
	this.filterResult = null;
}
ProductFilterMethodCall.prototype.getId = function()
{
	return this.id;
}
