/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Action</DEPENDS>
    <DEPENDS>SoundPlayer</DEPENDS>
    <DEPENDS>SoundBroker</DEPENDS>
    <DEPENDS>SoundRecorderBroker</DEPENDS>
    <DEPENDS>SoundRecorder</DEPENDS>
</DEPENDENCIES>
*/
function RoleInterval(sId, sRoleId, nStartTime, nEndTime, sSoundURL, nTimelimit)
{
  if (sId) { this.init(sId, sRoleId, nStartTime, nEndTime, sSoundURL, nTimelimit); }
}
RoleInterval.prototype.init = function(sId, sRoleId, nStartTime, nEndTime, sSoundURL, nTimelimit)
{
  ;
  this.sId = sId;
  this.sRoleId = sRoleId;
  this.nStartTime = nStartTime;
  this.nEndTime = nEndTime;
  this.nIndex = null;
  this.sSoundURL = sSoundURL;
  if(nTimelimit)
  {
    this.nTimelimit = nTimelimit;
  }
  else
  {
    this.nTimelimit = 45000;
  }
  this.oRecSoundBroker = null;
  this.oRecSoundPlayer = null;
  this.oPlaySoundBroker = null;
  this.oPlaySoundPlayer = null;
  this.oManager = null;
  this.bIsTouched = false;
  this.oRoleIntervalBroker = null;
  this.bIsActive = false;
  this.bTimeLimitReached = false;
  this.bPlay = false;
}
RoleInterval.prototype.getId = function()
{
  ;
  return this.sId;
}
RoleInterval.prototype.setManager = function(oManager)
{
  ;
  this.oManager = oManager;
}
RoleInterval.prototype.setRoleIntervalBroker = function(oRoleIntervalBroker)
{
  ;
  this.oRoleIntervalBroker = oRoleIntervalBroker;
  oRoleIntervalBroker.addRequestSetActiveHandle( this.getRequestSetActiveAction() );
}
RoleInterval.prototype.setSoundPlayer = function(oPlaySoundPlayer)
{
  ;
  this.oPlaySoundPlayer = oPlaySoundPlayer;
}
RoleInterval.prototype.setSoundRecorder = function(oRecSoundPlayer)
{
  ;
  this.oRecSoundPlayer = oRecSoundPlayer;
}
RoleInterval.prototype.start = function()
{
  ;
  if ( this.oManager )
  {
    this.createSoundPlayer();
    if (!this.oRecSoundPlayer)
      this.oRecSoundPlayer = new SoundRecorder(this.oManager.oSoundRecorderRegistry, this.sId + 'recorder_handle', this.nTimelimit);
  }
  else
  {
    ;
  }
}
RoleInterval.prototype.createSoundPlayer = function()
{
  ;
  if ( this.oManager )
  {
    if (!this.oPlaySoundPlayer)
    {
      this.oPlaySoundPlayer = new SoundPlayer(this.oManager.oSoundRegistry, this.sSoundURL);
    }
    this.oPlaySoundBroker = new SoundBroker(this.sId + '_sound_broker');
    this.oPlaySoundPlayer.setSoundBroker(this.oPlaySoundBroker);
    this.oPlaySoundBroker.addSoundStoppedHandle(this.getSoundStopAction());
    this.oPlaySoundBroker.addAbsoluteIntervalReachedHandle(this.getTimeChangeAction());
  }
}
RoleInterval.prototype.createSoundRecorder = function()
{
  ;
  if ( this.oManager )
  {
    if( ! this.oRecSoundPlayer )
    {
      ;
      this.oRecSoundPlayer= new SoundRecorder(this.oManager.oSoundRecorderRegistry, this.sId + '_recorder_handle', this.nTimelimit);
    }
    this.oRecSoundBroker = new SoundRecorderBroker(this.sId + '_sound_rec_broker');
    this.oRecSoundPlayer.setSoundBroker(this.oRecSoundBroker);
    this.oRecSoundBroker.addSoundStoppedHandle(this.getSoundStopAction());
    this.oRecSoundBroker.addRecordingStoppedHandle(this.getSoundStopAction());
    this.oRecSoundBroker.addRecordingTimeLimitReachedHandle(this.getSoundStopAction());
  }
}
RoleInterval.prototype.play = function()
{
  ;
  this.oManager.timeChange(this.nStartTime);
  this.bIsActive = true;
  this.bPlay = true;
  if(!this.bIsTouched)
  {
      this.bIsTouched = true;
      if ( this.oRoleIntervalBroker )
      {
        this.oRoleIntervalBroker.systemTouched();
      }
  }
  if ( this.oRecSoundBroker )
  {
    this.oRecSoundBroker.requestSoundStart();
  }
  else
  {
    if ( this.oPlaySoundBroker )
    {
      this.oPlaySoundBroker.requestSoundStart();
    }
    else
    {
      this.createSoundPlayer();
      this.oPlaySoundBroker.requestSoundStart();
    }
  }
}
RoleInterval.prototype.record = function()
{
  ;
  this.bIsActive = true; 
  this.oManager.timeChange(this.nStartTime);
  if(!this.bIsTouched)
  {
      this.bIsTouched = true;
      if ( this.oRoleIntervalBroker )
      {
        this.oRoleIntervalBroker.userTouched();
      }
  }
  if ( this.oRecSoundBroker )
  {
    this.oRecSoundBroker.requestRecordingStart();
  }
  else
  {
    this.createSoundRecorder();
    this.oRecSoundBroker.requestRecordingStart();
  }
}
RoleInterval.prototype.stopRecord = function()
{
  ;
  if ( this.oRecSoundBroker )
  {
    if (this.bTimeLimitReached)
    {
      this.bTimeLimitReached = false;
      this.soundStop();
    }
    else
    {
      this.oRecSoundBroker.requestStop();
    }
  }
  else
  {
    if (this.oPlaySoundBroker)
    {
      this.oPlaySoundBroker.requestSoundStop();
    }
  }
}
RoleInterval.prototype.timeChange = function(sAbsoluteTimeReached)
{
  ;
  if ( parseInt(sAbsoluteTimeReached) && this.oManager && this.bPlay)
  {
    this.oManager.timeChange(parseInt(sAbsoluteTimeReached) + parseInt(this.nStartTime) , true);
  }
}
RoleInterval.prototype.soundStop = function()
{
  ;
  this.bPlay = false;
  if ( this.oManager )
  {
    this.bIsActive = false;
    this.oManager.timeChange(this.nEndTime);
    this.oManager.roleIntervalPlayed(this);
  }
}
RoleInterval.prototype.timeLimitReached = function()
{
  ;
  if ( this.oManager )
  {
    this.oManager.timeLimitReached(this);
  }
}
RoleInterval.prototype.requestSetActive = function()
{
  ;
  if ( this.oManager )
  { 
    this.oManager.requestSetRoleIntervalActive(this);
  }
}
RoleInterval.prototype.getRequestSetActiveAction = function()
{
  return new ObjectMethodAction(this, "requestSetActive");
}
RoleInterval.prototype.getTimeChangeAction = function()
{
  return new ObjectMethodAction(this, "timeChange");
}
RoleInterval.prototype.getTimeLimitReachedAction = function()
{
  return new ObjectMethodAction(this, "timeLimitReached");
}
RoleInterval.prototype.getSoundStopAction = function()
{
  return new ObjectMethodAction(this, "soundStop");
}
