/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>SequenceAdapter</DEPENDS>
</DEPENDENCIES>
*/
SequenceManager.prototype             = new SequenceAdapter();
SequenceManager.prototype.constructor = SequenceManager;
SequenceManager.superclass            = SequenceAdapter.prototype;
function SequenceManager(sId, sWidgetDomId)
{
  if (sId) { this.init(sId, sWidgetDomId); }
}
SequenceManager.prototype.init = function(sId, sWidgetDomId)
{
  ;
  SequenceManager.superclass.init.call(this, sId, sWidgetDomId);
  this.aSequencelets = new Array();
  this.nSequencelets = 0;
  this.aAnchors = new Array();
  this.nAnchors = 0;
  this.nPadding = 0;
  this.bRemoveSequenceletWhileDrag = true;
  this.trailer = null;
  this.position = new Point(0,0);
  Browser.getAbsPos(this.widget, this.position);
}
SequenceManager.prototype.start = function()
{
  ;
  this.arrangeSequencelets();
}
SequenceManager.prototype.registerSequencelet = function(sequencelet)
{
  ;
  if (this.aSequencelets[sequencelet.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSequencelets[sequencelet.getId()] = sequencelet;
    this.nSequencelets++;
    ;
    sequencelet.setSequenceManager(this);
  }
}
SequenceManager.prototype.registerAnchor = function(anchor)
{
  ;
  if (this.aAnchors[anchor.nPos] != null)
  {
    ;
  }
  else
  {
    this.aAnchors[anchor.nPos] = anchor;
    this.nAnchors++;
    ;
  }
}
SequenceManager.prototype.findSequenceletBySequenceItem = function(sequenceItem)
{
  ;
  var sequencelet = null;
  for (var id in this.aSequencelets)
  {
    if (this.aSequencelets[id].getModelItem() == sequenceItem)
    {
      sequencelet = this.aSequencelets[id];
      break;
    }
  }
  return sequencelet;
}
SequenceManager.prototype.arrangeSequencelets = function()
{
  ;
  this.position = new Point(0,0);
  Browser.getAbsPos(this.widget, this.position);
  var sequencelet = null;
  var nConsumedWidth = 0;
  var nConsumedHeight = 0;
  var sequenceItem = null;
  var i = 0;
  while (this.aAnchors[i]||(sequenceItem = this.modelItem.getSequence().getNextSequenceItem(sequenceItem)) != null)
  {
    if ( this.aAnchors[i] )
    {
      if ((nConsumedWidth + this.aAnchors[i].getWidth()) > this.widget.offsetWidth)
      {
        nConsumedHeight += this.aAnchors[i].getHeight() + this.nPadding;
        nConsumedWidth = 0;
      }
      this.aAnchors[i].moveTo(new Point(this.position.x + nConsumedWidth, this.position.y + nConsumedHeight));
      nConsumedWidth += this.aAnchors[i].getWidth() + this.nPadding;
    }
    else
    {
      sequencelet = this.findSequenceletBySequenceItem(sequenceItem);
      if (sequencelet)
      {
        if ((nConsumedWidth + sequencelet.getWidth()) > this.widget.offsetWidth)
        {
          nConsumedHeight += sequencelet.getHeight() + this.nPadding;
          nConsumedWidth = 0;
        }
        if ( nConsumedHeight )
        {
          sequencelet.sLine = null;
        }
        else
        {
          sequencelet.sLine = 'first';
        }
        sequencelet.moveTo(new Point(this.position.x + nConsumedWidth, this.position.y + nConsumedHeight));
        nConsumedWidth += sequencelet.getWidth() + this.nPadding;
      }
    }
    i++;
  }
}
SequenceManager.prototype.setPadding = function(nPadding)
{
  ;
  this.nPadding = nPadding;
}
SequenceManager.prototype.setRemoveSequenceletWhileDrag = function(bRemoveSequenceletWhileDrag)
{
  ;
  this.bRemoveSequenceletWhileDrag = bRemoveSequenceletWhileDrag;
}
SequenceManager.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if (this.broker)
      {
        this.broker.showCorrect();
      }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  this.arrangeSequencelets();
}
SequenceManager.prototype.beginDrag = function(sequencelet)
{
  ;
  if (this.bRemoveSequenceletWhileDrag)
  {
    this.modelItem.removeSequenceItem(sequencelet.getModelItem());
  }
}
SequenceManager.prototype.endDrag = function(sequencelet)
{
  ;
  var sequenceItem = null;
  var position = 0;
  var firstSequenceItem = this.modelItem.getSequence().getNextSequenceItem(null);
  var firstSequencelet = this.findSequenceletBySequenceItem(firstSequenceItem);
  var deltaY = sequencelet.getPosition().y - firstSequencelet.getPosition().y;
  var line = 0;
  if (deltaY > 0) 
  {
    line = Math.floor(deltaY / (firstSequencelet.getHeight() + this.nPadding));
  }
  var extrapolatedX = sequencelet.getPosition().x + line * this.widget.offsetWidth;
  var while_sequencelet = null;
  var i = 0;
  while ((sequenceItem = this.modelItem.getSequence().getNextSequenceItem(sequenceItem)) != null)
  {
    while_sequencelet = this.findSequenceletBySequenceItem(sequenceItem);
    if (while_sequencelet)
    {
      if (while_sequencelet.getPosition().y > sequencelet.getPosition().y )
      {
        if ( while_sequencelet.sLine != 'first')
        {
          break;
        }
      }
      if (while_sequencelet.getPosition().x > sequencelet.getPosition().x && ( while_sequencelet.getPosition().y + while_sequencelet.getHeight()) > sequencelet.getPosition().y)
      {
        break;
      }
    }
    i++;
  }
  if (!this.bRemoveSequenceletWhileDrag)
  {
    var nOldPosition = this.modelItem.getPositionOfSequenceItem(sequencelet.getModelItem());
    if (nOldPosition < i)
    {
      i -= 1; 
    }
  }
  this.modelItem.moveSequenceItemAtPosition(sequencelet.getModelItem(), i);
}
