/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>HandleMap</DEPENDS>
    <DEPENDS>SoundHandle</DEPENDS>
    <DEPENDS>SoundPlayer</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
</DEPENDENCIES>
*/
function SoundPlayerRegistryManager(id, corePlayerHandle)
{
	;
	this.corePlayerHandle = corePlayerHandle;
	this.playerArray = new Array();
	this.playerHandleCount = 0;
	this.soundHandles = new Array();
	this.broker = new SoundPlayerRegistryManagerBroker();
	HandleMap.instance.registerHandle(id, this);
}
SoundPlayerRegistryManager.prototype.register = function(player, handleName)
{
	;
	var soundhandle;
	var alreadyRegistered;
	if (handleName)
	{
		alreadyRegistered = true;
		soundhandle = handleName;
		;
	}
	else
	{
		alreadyRegistered = false;
		soundhandle = 'js_soundplayer_handle_' + this.playerHandleCount++;
		;
	}
	
	if (player)
	{
		;
		this.soundHandles[player.soundurl] = soundhandle;
	}
	if (this.playerArray[soundhandle])
	{
		;
	}
	else
	{
		this.playerArray[soundhandle] = player;
		
		try
		{
			if (this.corePlayerHandle != undefined)
			{
				if (!alreadyRegistered)
				{
					HandleMap.instance.sendMessage(this.corePlayerHandle, 'soundRegisterAbsolute', [soundhandle, 500, player.soundurl]);
				}
				return new SoundHandle(player, player.soundurl, this.corePlayerHandle, soundhandle);
			}
			else
			{
				
				return new SoundHandle(player, player.soundurl, undefined, soundhandle);
			}
		}
		catch (e)
		{
			;
		}
	}
	
	return new SoundHandle(player, player.soundurl, undefined, soundhandle);
}
SoundPlayerRegistryManager.prototype.getPlayer = function(handle)
{
	return this.playerArray[handle];
}
SoundPlayerRegistryManager.prototype.getHandle = function(soundURl)
{
	return this.soundHandles[soundURl];
}
SoundPlayerRegistryManager.prototype.registerSound = function(url, soundbroker)
{
	;
	soundPlayer = new SoundPlayer(this, url);
	;
	soundPlayer.setSoundBroker(soundBroker);
	
	return soundPlayer;
}
SoundPlayerRegistryManager.prototype.broadcastSpeedFactor = function(speedFactor)
{
	eval('document.' + this.corePlayerHandle + '.speedfactorbroadcast(speedFactor)');
	HandleMap.instance.sendMessage(this.corePlayerHandle, 'speedfactorbroadcast', [speedFactor]);
}
SoundPlayerRegistryManager.prototype.play = function(handle)
{
	;
	soundPlayer = this.playerArray[handle];
	soundPlayer.play();
}
SoundPlayerRegistryManager.prototype.stop = function(handle)
{
	soundPlayer = this.playerArray[handle];
	soundPlayer.stop();
}
SoundPlayerRegistryManager.prototype.pause = function(handle)
{
	soundPlayer = this.playerArray[handle];
	soundPlayer.pause();
}
SoundPlayerRegistryManager.prototype.rewind = function(handle, amount)
{
	soundPlayer = this.playerArray[handle];
	soundPlayer.rewind(amount);
}
SoundPlayerRegistryManager.prototype.forward = function(handle, amount)
{
	soundPlayer = this.playerArray[handle];
	soundPlayer.forward(amount);
}
SoundPlayerRegistryManager.prototype.setTimePositionAbsolute = function(handle, time)
{
	;
	soundPlayer = this.playerArray[handle];
	;
	if (soundPlayer)
		soundPlayer.soundBroker.doAbsoluteIntervalReached(time);
}
SoundPlayerRegistryManager.prototype.notifyStart = function(handle)
{
	
	this.broker.activated();
	;
	soundPlayer = this.playerArray[handle];
	;
	if (soundPlayer)
		soundPlayer.soundBroker.doSoundStarted();
	
}
SoundPlayerRegistryManager.prototype.notifyStop = function(handle)
{
	;
	soundPlayer = this.playerArray[handle];
	;
	if(soundPlayer)
        soundPlayer.soundBroker.doSoundStopped();
	
}
SoundPlayerRegistryManager.prototype.notifyPause = function(handle)
{
	;
	soundPlayer = this.playerArray[handle];
	;
	if(soundPlayer)
        soundPlayer.soundBroker.doSoundPaused();
}
SoundPlayerRegistryManager.prototype.getResetAllAction = function()
{
	return new ObjectMethodAction(this, 'resetAll');
}
SoundPlayerRegistryManager.prototype.resetAll = function()
{
	;
	HandleMap.instance.sendMessage(this.corePlayerHandle, 'reset', []);
}
SoundPlayerRegistryManager.prototype.setSoundPlayerSpeed = function(speedfactor)
{
	;
	HandleMap.instance.sendMessage(this.corePlayerHandle, 'speedfactorbroadcast', [speedfactor]);
}
SoundPlayerRegistryManager.prototype.getSpeedAction = function()
{
	return new ObjectMethodAction(this, 'setSoundPlayerSpeed');
}
SoundPlayerRegistryManager.prototype.addActivatedHandle = function(action)
{
	this.broker.addActivatedHandle( action);
}
SoundPlayerRegistryManagerBroker.prototype = new Broker();
SoundPlayerRegistryManagerBroker.prototype.constructor = SoundPlayerRegistryManagerBroker;
SoundPlayerRegistryManagerBroker.superclass = Broker.prototype;
function SoundPlayerRegistryManagerBroker()
{
}
SoundPlayerRegistryManagerBroker.prototype.addActivatedHandle = function(action)
{
	;
	this.registerAction("activated", action);
}
SoundPlayerRegistryManagerBroker.prototype.activated = function()
{
	;
	
	this.getMessage("activated");
}
