/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>BasicChoiceTipStrategy</DEPENDS>
    <DEPENDS>LimitingChoiceTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
function BasicChoiceTipStrategy(sId)
{
  this.init(sId)
}
BasicChoiceTipStrategy.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.workItem = null;
  this.aValueItemIds = null;
}
BasicChoiceTipStrategy.prototype.getId = function()
{
  return this.sId;
}
BasicChoiceTipStrategy.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
}
BasicChoiceTipStrategy.prototype.start = function()
{
  ;
}
BasicChoiceTipStrategy.prototype.createValueItemIdEnumeration= function()
{
  ;
  if (this.aValueItemIds == null)
  {
    this.aValueItemIds = new Array();
    var bRandom = true;
    if (true) {
      var nIndex = 0;
      for (var id in this.workItem.aValues)
      {
        this.aValueItemIds[nIndex++] = id;
      }
    }
    if (bRandom) {
      shuffleArray(this.aValueItemIds);
    }
  }
}
BasicChoiceTipStrategy.prototype.hasTip = function(bStepByStep, bSolutable)
{
  ;
  var bHasTip = false;
  var tipItem = this.getTipItem(bStepByStep, bSolutable);
  if (tipItem != null)
  {
    bHasTip = true;
  }
  return bHasTip;
}
BasicChoiceTipStrategy.prototype.showTip = function(bStepByStep, bSolutable)
{
  ;
  var tipItem = this.getTipItem(bStepByStep, bSolutable);
  if (tipItem != null)
  {
    var bNewValue = tipItem.getSolution();
    ;
    tipItem.setValueBySystem(bNewValue);
  }
  else
  {
    ;
  }
}
BasicChoiceTipStrategy.prototype.getTipItem = function(bStepByStep, bSolutable)
{
  ;
  this.createValueItemIdEnumeration() 
  var tipItem = null;
  for (var i = 0; i < this.aValueItemIds.length; i++)
  {
    var valueItem = this.workItem.aValues[ this.aValueItemIds[i] ];
    ;
    if (this.checkTipItem(valueItem))
    {
      ;
      tipItem = valueItem;
      break;
    }
  }
  return tipItem;
}
BasicChoiceTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return !valueItem.getValue() && valueItem.getSolution();
}
LimitingChoiceTipStrategy.prototype             = new BasicChoiceTipStrategy();
LimitingChoiceTipStrategy.prototype.constructor = LimitingChoiceTipStrategy;
LimitingChoiceTipStrategy.superclass            = BasicChoiceTipStrategy.prototype;
function LimitingChoiceTipStrategy(sId, bCorrectNumberKnown)
{
  this.init(sId, bCorrectNumberKnown)
}
LimitingChoiceTipStrategy.prototype.init = function(sId, bCorrectNumberKnown)
{
  ;
  LimitingChoiceTipStrategy.superclass.init.call(this, sId);
  this.bCorrectNumberKnown = bCorrectNumberKnown;
}
LimitingChoiceTipStrategy.prototype.getTipItem = function(bStepByStep, bSolutable)
{
  ;
  this.createValueItemIdEnumeration() 
  var tipItem = null;
  var execStatus = this.workItem.getExerciseStatus();
  //;
  var nTipsUntilSolvedBeforeTip = (execStatus.nCorrect - execStatus.nCorrectSystem) + (execStatus.nWrong - execStatus.nWrongSystem);
  //;
  for (var i = 0; i < this.workItem.nValues; i++)
  {
    var valueItem = this.workItem.aValues[ this.aValueItemIds[i] ];
    var nTipsUntilSolvedAfterTip = nTipsUntilSolvedBeforeTip;
    if (!valueItem.hasSystemContribution())
    {
      nTipsUntilSolvedAfterTip -= 1;
    }
    var bUseThisValueItem = true;
    if (!bSolutable)
    {
      if (nTipsUntilSolvedAfterTip <= 0) {
        ;
        bUseThisValueItem = false;
      } else if (this.bCorrectNumberKnown && nTipsUntilSolvedAfterTip <= 1) {
        ;
        bUseThisValueItem = false;
      }
    }
    if (bUseThisValueItem) {
      ;
      if (this.checkTipItem(valueItem))
      {
        ;
        tipItem = valueItem;
        break;
      }
    }
  }
  return tipItem;
}
ShowMissingOnChoiceTipStrategy.prototype             = new LimitingChoiceTipStrategy();
ShowMissingOnChoiceTipStrategy.prototype.constructor = ShowMissingOnChoiceTipStrategy;
ShowMissingOnChoiceTipStrategy.superclass            = LimitingChoiceTipStrategy.prototype;
function ShowMissingOnChoiceTipStrategy(sId, bCorrectNumberKnown)
{
  this.init(sId, bCorrectNumberKnown)
}
ShowMissingOnChoiceTipStrategy.prototype.init = function(sId, bCorrectNumberKnown)
{
  ;
  ShowMissingOnChoiceTipStrategy.superclass.init.call(this, sId, bCorrectNumberKnown);
  this.bCorrectNumberKnown = bCorrectNumberKnown;
}
ApproveCorrectOnChoiceTipStrategy.prototype             = new LimitingChoiceTipStrategy();
ApproveCorrectOnChoiceTipStrategy.prototype.constructor = ApproveCorrectOnChoiceTipStrategy;
ApproveCorrectOnChoiceTipStrategy.superclass            = LimitingChoiceTipStrategy.prototype;
function ApproveCorrectOnChoiceTipStrategy(sId, bCorrectNumberKnown)
{
  this.init(sId, bCorrectNumberKnown)
}
ApproveCorrectOnChoiceTipStrategy.prototype.init = function(sId, bCorrectNumberKnown)
{
  ;
  ApproveCorrectOnChoiceTipStrategy.superclass.init.call(this, sId, bCorrectNumberKnown);
  this.bCorrectNumberKnown = bCorrectNumberKnown;
}
ApproveCorrectOnChoiceTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return valueItem.getValue() && valueItem.getSolution() && valueItem.getOrigin() == 'user';
}
RemoveWrongOnChoiceTipStrategy.prototype             = new LimitingChoiceTipStrategy();
RemoveWrongOnChoiceTipStrategy.prototype.constructor = RemoveWrongOnChoiceTipStrategy;
RemoveWrongOnChoiceTipStrategy.superclass            = LimitingChoiceTipStrategy.prototype;
function RemoveWrongOnChoiceTipStrategy(sId, bCorrectNumberKnown)
{
  this.init(sId, bCorrectNumberKnown)
}
RemoveWrongOnChoiceTipStrategy.prototype.init = function(sId, bCorrectNumberKnown)
{
  ;
  RemoveWrongOnChoiceTipStrategy.superclass.init.call(this, sId, bCorrectNumberKnown);
  this.bCorrectNumberKnown = bCorrectNumberKnown;
}
RemoveWrongOnChoiceTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return valueItem.getValue() && !valueItem.getSolution() && valueItem.getOrigin() == 'user';
}
ApproveCorrectOffChoiceTipStrategy.prototype             = new LimitingChoiceTipStrategy();
ApproveCorrectOffChoiceTipStrategy.prototype.constructor = ApproveCorrectOffChoiceTipStrategy;
ApproveCorrectOffChoiceTipStrategy.superclass            = LimitingChoiceTipStrategy.prototype;
function ApproveCorrectOffChoiceTipStrategy(sId, bCorrectNumberKnown)
{
  this.init(sId, bCorrectNumberKnown)
}
ApproveCorrectOffChoiceTipStrategy.prototype.init = function(sId, bCorrectNumberKnown)
{
  ;
  ApproveCorrectOffChoiceTipStrategy.superclass.init.call(this, sId, bCorrectNumberKnown);
  this.bCorrectNumberKnown = bCorrectNumberKnown;
}
ApproveCorrectOffChoiceTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return !valueItem.getValue() && !valueItem.getSolution() && valueItem.getOrigin() != 'system';
}
