/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>BasicQeaCorrectionStrategy</DEPENDS>
</DEPENDENCIES>
*/
QuestionBasedQeaCorrectionStrategy.prototype             = new BasicQeaCorrectionStrategy();
QuestionBasedQeaCorrectionStrategy.prototype.constructor = QuestionBasedQeaCorrectionStrategy;
QuestionBasedQeaCorrectionStrategy.superclass            = BasicQeaCorrectionStrategy.prototype;
function QuestionBasedQeaCorrectionStrategy(sId, nRemoveWrongTime, nShowCorrectTime, nPatience)
{
  this.init(sId, nRemoveWrongTime, nShowCorrectTime,  nPatience)
}
QuestionBasedQeaCorrectionStrategy.prototype.init = function(sId, nRemoveWrongTime, nShowCorrectTime,  nPatience)
{
  ;
  this.nRemoveWrongTime = nRemoveWrongTime;
  this.nShowCorrectTime = nShowCorrectTime;
  this.nPatience = nPatience;
  this.nHandles = 0;
  this.questionTrials = new Array();
  QuestionBasedQeaCorrectionStrategy.superclass.init.call(this, sId);
}
QuestionBasedQeaCorrectionStrategy.prototype.lostPatience = function(question)
{
  var workItem = this.getLastWorkItem();
  if(!workItem)
    return false;
  var status = workItem.getExerciseStatus();
  var trials = this.questionTrials[question.sId];
  if(trials)
  {
    trials++;
    this.questionTrials[question.sId] = trials;
  }
  else
  {
    trials = 1;
    this.questionTrials[question.sId] = trials;
  }
  if((this.nPatience == 0) || (this.nPatience < 100) && ((trials / status.nCorrect) > (this.nPatience / 100)))
  {
    return true;
  }
  else
  {
    return false;
  }
}
QuestionBasedQeaCorrectionStrategy.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = this.getLastEvaluation();
  if(lastEvaluation)
  {
    var sHandleId = this.sId + '_' + this.nHandles++;
    var oHandle = new QuestionBasedQeaCorrectionStrategyHandle(sHandleId, this, lastEvaluation);
    oHandle.showCorrection();
  }
}
QuestionBasedQeaCorrectionStrategy.prototype.reset = function()
{
  this.questionTrials = new Array();
}
QuestionBasedQeaCorrectionStrategy.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, "reset");
}
var staticQuestionBasedQeaCorrectionStrategyHandle = new Array();
QuestionBasedQeaCorrectionStrategyHandle_getInstance = function(sId)
{
  var Instance = null;
  if ( staticQuestionBasedQeaCorrectionStrategyHandle[sId] )
  {
    Instance = staticQuestionBasedQeaCorrectionStrategyHandle[sId];
  }
  return Instance;
}
function QuestionBasedQeaCorrectionStrategyHandle(sId, strategy, lastEvaluation)
{
  this.init(sId, strategy, lastEvaluation);
}
QuestionBasedQeaCorrectionStrategyHandle.prototype.init = function(sId, strategy, lastEvaluation)
{
  ;
  this.sId = sId;
  this.strategy = strategy;
  this.lastEvaluation = lastEvaluation;
  this.aTimerEvaluations = new Array();
  staticQuestionBasedQeaCorrectionStrategyHandle[sId] = this;
}
QuestionBasedQeaCorrectionStrategyHandle.prototype.hasCorrection = function()
{
  ;
  var bHasCorrection = true;
  if (! (bHasCorrection && this.lastEvaluation))
  {
    bHasCorrection = false;
  }
  return bHasCorrection;
}
QuestionBasedQeaCorrectionStrategyHandle.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = null;
  if (this.hasCorrection())
  {
    lastEvaluation = this.lastEvaluation;
  }
  if ( lastEvaluation )
  {
    if ( lastEvaluation.isCorrect() )
    {
      if ( lastEvaluation.isActive() )
      {
        var bSystemConstructive = lastEvaluation.bSystemConstructive;
        lastEvaluation.setActive(true, 'system_approve');
        lastEvaluation.bSystemConstructive = bSystemConstructive;
        lastEvaluation.workItem.changed(lastEvaluation);
        this.lastTippedEvaluation = lastEvaluation;
      }
      else
      {
      }
    }
    else
    {
      if( lastEvaluation.isActive() )
      {
        this.strategy.exerciseManager.beginCorrection();
        var bSystemConstructive = lastEvaluation.bSystemConstructive;
        lastEvaluation.setSilentlyActive(true, 'system_brand');
        lastEvaluation.bSystemConstructive = bSystemConstructive;
        lastEvaluation.workItem.changed(lastEvaluation);
        this.aTimerEvaluations.push(lastEvaluation);
        this.lastTippedEvaluation = lastEvaluation;
        window.setTimeout('QuestionBasedQeaCorrectionStrategyHandle_getInstance(\''+this.sId+'\').removeWrong();', this.strategy.nRemoveWrongTime);
      }
      else
      {
      }
    }
  }
}
QuestionBasedQeaCorrectionStrategyHandle.prototype.removeWrong = function()
{
  ;
  var evaluation = this.aTimerEvaluations.pop();
  evaluation.setActive(false, 'system_set');
  var question = evaluation.getQuestion();
  if( this.strategy.lostPatience(question) )
  {
    var solutionEvaluation = this.strategy.findTippableEvaluation(question);
    if ( solutionEvaluation != null )
    {
      this.aTimerEvaluations.push(solutionEvaluation);
      window.setTimeout('QuestionBasedQeaCorrectionStrategyHandle_getInstance(\''+this.sId+'\').showCorrect();', this.strategy.nShowCorrectTime);
    }
  }
  else
  {
    this.strategy.exerciseManager.endCorrection();
  }
}
QuestionBasedQeaCorrectionStrategyHandle.prototype.showCorrect = function()
{
  ;
  var evaluation = this.aTimerEvaluations.pop();
  evaluation.setActive(true, 'system_approve');
  this.lastTippedEvaluation = evaluation;
  this.strategy.exerciseManager.endCorrection();
}
