/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>ExerciseManagerStatus</DEPENDS>
</DEPENDENCIES>
*/
function ExerciseManagerStatus( nTouched, nTotal, nCorrect, nWrong, nCorrectStatus, nWrongStatus, nCorrectSystem,
                                nWrongSystem, sOrigin )
{
  this.nTouched = nTouched;
  this.nTotal = nTotal;
  this.nCorrect = nCorrect;
  this.nWrong = nWrong;
  this.nCorrectStatus = nCorrectStatus;
  this.nWrongStatus = nWrongStatus;
  this.nCorrectSystem = nCorrectSystem;
  this.nWrongSystem = nWrongSystem;
  this.oWorkItem = null;
  this.sOrigin = sOrigin;
}
ExerciseManagerStatus.prototype.toString = function()
{
  return '[' +
         'items:touched=' + this.nTouched +
         '/total=' + this.nTotal +
         ' ' +
         'total:correct=' + this.nCorrect +
         '/wrong=' + this.nWrong +
         ' ' +
         'status:correct=' + this.nCorrectStatus +
         '/wrong=' + this.nWrongStatus +
         ' ' +
         'sys:const=' + this.nCorrectSystem +
         '/corr=' + this.nWrongSystem +
         ']';
}
ExerciseHandlerStatus.prototype = new ExerciseManagerStatus();
ExerciseHandlerStatus.prototype.constructor = ExerciseHandlerStatus;
ExerciseHandlerStatus.superclass = ExerciseManagerStatus.prototype;
function ExerciseHandlerStatus( nCorrect, nWrong, nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem, oWorkItem,
                                sOrigin )
{
  this.nTouched = -1;
  this.nTotal = -1;
  this.nCorrect = nCorrect;
  this.nWrong = nWrong;
  this.nCorrectStatus = nCorrectStatus;
  this.nWrongStatus = nWrongStatus;
  this.nCorrectSystem = nCorrectSystem;
  this.nWrongSystem = nWrongSystem;
  this.oWorkItem = oWorkItem;
  this.sOrigin = sOrigin;
}
function ExerciseManager( sId )
{
  this.init(sId)
}
ExerciseManager.prototype.init = function( sId )
{
  ;
  this.sId = sId;
  this.aExcHandlers = new Array();
  this.aStatus = new Array();
  this.excStatus = new ExerciseManagerStatus(0, 0, 0, 0, 0, 0, 0, 0);
  this.aTouchedHandler = new Array();
  this.bWorkStarted = false;
  this.bWorkStopped = false;
  this.bHelpApplied = false;
  this.bActivated = false;
  this.bReset = false;
  this.currentExecHandler = null;
  this.oExerciseBroker = null;
  this.aCorrectionStrategys = new Array();
}
ExerciseManager.prototype.setExerciseBroker = function( oExerciseBroker )
{
  ;
  this.oExerciseBroker = oExerciseBroker;
  this.oExerciseBroker.addResetHandle(this.getResetAction());
  this.oExerciseBroker.addEvaluateHandle(this.getEvaluateAction());
}
ExerciseManager.prototype.register = function( excHandler )
{
  ;
  if( this.aExcHandlers[excHandler.getId()] != null )
  {
    ;
  }
  else
  {
    this.aExcHandlers[excHandler.getId()] = excHandler;
    this.excStatus.nTotal++;
    ;
    this.setCurrent(excHandler);
    excHandler.setExerciseManager(this);
  }
}
ExerciseManager.prototype.start = function()
{
  ;
  for( var id in this.aExcHandlers )
  {
    this.aExcHandlers[id].start();
  }
  this.initExcStatus();
}
ExerciseManager.prototype.registerCorrectionStrategy = function( oCorrectionStrategy )
{
  ;
  this.aCorrectionStrategys.push(oCorrectionStrategy);
  oCorrectionStrategy.setExerciseManager(this);
}
ExerciseManager.prototype.initExcStatus = function()
{
  ;
  if( this.excStatus.nTotal == 0 )  
  {
    if( this.oExerciseBroker != null )
    {
      this.oExerciseBroker.solved(
              new ExerciseManagerStatus(1, 1, 1, 0, 1, 0, 0, 0));
    }
  }
  this.excStatus.nTouched = 0;
  this.excStatus.nCorrect = 0;
  this.excStatus.nWrong = 0;
  this.excStatus.nCorrectStatus = 0;
  this.excStatus.nWrongStatus = 0;
  this.excStatus.nCorrectSystem = 0;
  this.excStatus.nWrongSystem = 0;
  for( var id in this.aExcHandlers )
  {
    this.excStatus.nCorrect += this.aExcHandlers[id].getNumCorrect();
    this.excStatus.nWrong += this.aExcHandlers[id].getNumWrong();
  }
}
ExerciseManager.prototype.setCurrent = function( execHandler )
{
  ;
  this.currentExecHandler = execHandler;
}
ExerciseManager.prototype.solved = function( excHandler, excHandlerStatusNew )
{
  ;
  if( this.aExcHandlers[excHandler.getId()] == null )
  {
    ;
  }
  else
  {
    if( !this.aTouchedHandler[excHandler.getId()] )
    {
      if( excHandlerStatusNew.oWorkItem.bWorkStarted )
      {
        ;
        this.aTouchedHandler[excHandler.getId()] = true;
        this.excStatus.nTouched++;
      }
    }
    var excHandlerStatusOld = this.aStatus[excHandler.getId()];
    if( excHandlerStatusOld != null )
    {
      ;
      this.excStatus.nCorrectStatus -= excHandlerStatusOld.nCorrectStatus;
      this.excStatus.nWrongStatus -= excHandlerStatusOld.nWrongStatus;
      this.excStatus.nCorrectSystem -= excHandlerStatusOld.nCorrectSystem;
      this.excStatus.nWrongSystem -= excHandlerStatusOld.nWrongSystem;
      if( this.excStatus.nCorrectStatus < 0 )
        this.excStatus.nCorrectStatus = 0;
      if( this.excStatus.nWrongStatus < 0 )
        this.excStatus.nWrongStatus = 0;
      if( this.excStatus.nCorrectSystem < 0 )
        this.excStatus.nCorrectSystem = 0;
      if( this.excStatus.nWrongSystem < 0 )
        this.excStatus.nWrongSystem = 0;
    }
    if( excHandlerStatusNew.oWorkItem.bWorkStarted )
    {
      this.aStatus[excHandler.getId()] = excHandlerStatusNew;
      this.excStatus.nCorrectStatus += excHandlerStatusNew.nCorrectStatus;
      this.excStatus.nWrongStatus += excHandlerStatusNew.nWrongStatus;
      this.excStatus.nCorrectSystem += excHandlerStatusNew.nCorrectSystem;
      this.excStatus.nWrongSystem += excHandlerStatusNew.nWrongSystem;
      this.excStatus.sOrigin = excHandlerStatusNew.sOrigin;
    }
    this.setCurrent(excHandler);
    ;
    if( !this.bWorkStarted && !this.bReset )
    {
      if( excHandlerStatusNew.oWorkItem.bWorkStarted )
      {
        this.bWorkStarted = true;
        if( this.oExerciseBroker )
        {
          this.oExerciseBroker.doWorkStarted();
        }
      }
    }
    if( this.oExerciseBroker )
    {
      if( !this.bWorkStopped )
      {
        var bWorkStopped = true;
        for( var i in this.aExcHandlers )
        {
          if( ! this.aExcHandlers[i].bWorkStopped )
          {
            bWorkStopped = false;
          }
        }
        if( bWorkStopped )
        {
          this.oExerciseBroker.doWorkStopped();
        }
        this.bWorkStopped = bWorkStopped;
      }
      if( this.bWorkStarted && !this.bWorkStopped )
      {
        this.oExerciseBroker.doSolved(this.excStatus);
        this.oExerciseBroker.doWorkItemSolved(excHandlerStatusNew);
      }
      if( ! this.bHelpApplied && ((this.excStatus.nCorrectSystem > 0) || (this.excStatus.nWrongSystem > 0)) )
      {
        this.bHelpApplied = true;
        this.oExerciseBroker.doHelpApplied();
      }
    }
  }
}
ExerciseManager.prototype.evaluate = function()
{
  ;
  for( var id in this.aExcHandlers )
  {
    if( this.aExcHandlers[id].evaluate )
    {
      this.aExcHandlers[id].evaluate();
    }
  }
}
ExerciseManager.prototype.reset = function()
{
  ;
  this.bReset = true;
  if( this.oExerciseBroker )
  {
    var bWorkStarted = false;
    for( var id in this.aExcHandlers )
    {
      if( this.aExcHandlers[id].bWorkStarted )
      {
        bWorkStarted = true;
        break;
      }
    }
    if( bWorkStarted )
    {
      this.oExerciseBroker.doWorkAborted();
    }
  }
  for( var id in this.aExcHandlers )
  {
    if( this.aExcHandlers[id].reset )
    {
      this.aExcHandlers[id].reset();
    }
  }
  this.initExcStatus();
  this.aStatus = new Array();
  this.aTouchedHandler = new Array();
  this.bHelpApplied = false;
  this.bActivated = false;
  this.bWorkStarted = false;
  this.bWorkStopped = false;
  this.bReset = false;
}
ExerciseManager.prototype.beginCorrection = function()
{
  ;
  if( this.oExerciseBroker )
  {
    this.oExerciseBroker.beginCorrection();
  }
}
ExerciseManager.prototype.endCorrection = function()
{
  ;
  if( this.oExerciseBroker )
  {
    this.oExerciseBroker.endCorrection();
  }
}
ExerciseManager.prototype.activateExercise = function()
{
  if( !this.bActivated )
  {
    this.bActivated = true;
    if( this.oExerciseBroker )
    {
      this.oExerciseBroker.activated();
    }
  }
}
ExerciseManager.prototype.workItemStarted = function( exerciseHandler )
{
  if( this.oExerciseBroker )
  {
    this.oExerciseBroker.workItemStarted();
  }
}
ExerciseManager.prototype.workItemStopped = function( exerciseHandler )
{
  if( this.oExerciseBroker )
  {
    this.oExerciseBroker.workItemStopped();
  }
}
ExerciseManager.prototype.workItemAborted = function( exerciseHandler )
{
  if( this.oExerciseBroker )
  {
    this.oExerciseBroker.workItemAborted();
  }
}
ExerciseManager.prototype.workItemActivated = function( exerciseHandler )
{
  if( this.oExerciseBroker )
  {
    this.oExerciseBroker.workItemActivated();
  }
  this.activateExercise();
}
ExerciseManager.prototype.getResetAction = function()
{
  ;
  return new ObjectMethodAction(this, "reset");
}
ExerciseManager.prototype.getEvaluateAction = function()
{
  return new ObjectMethodAction(this, 'evaluate');
}
