/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>SCORMAPIWrapper</DEPENDS>
    <DEPENDS>HandleMap</DEPENDS>
</DEPENDENCIES>
*/
var LMS_SCORE = "cmi.core.score.raw";
var LMS_SCORE_MIN = "cmi.core.score.min";
var LMS_SCORE_MAX = "cmi.core.score.max";
var LMS_USER_ID = "cmi.core.student_id";
var LMS_USER_NAME = "cmi.core.student_name";
var LMS_ENTRY = "cmi.core.entry";
var LMS_CREDIT = "cmi.core.credit";
var LMS_STATUS = "cmi.core.lesson_status";
var LMS_SESSIONTIME = "cmi.core.session_time";
var LMS_TOTALTIME = "cmi.core.total_time";
var LMS_LOCATION = "cmi.core.lesson_location";
var LMS_EXIT ="cmi.core.exit";
SCORMAdapter.ADAPTERTYPE = "scorm12";
SCORMAdapter.PARAM_LMS_USERID = "lms_userid";
SCORMAdapter.PARAM_LMS_USERNAME = "lms_username";
SCORMAdapter.PARAM_LMS_ADAPTERTYPE = "lms_adaptertype";
SCORMAdapter.PARAM_LMS_PLATTFORM = "lms_plattform";
SCORMAdapter.PARAM_LMS2WBT = "lms2wbt";
function SCORMAdapter(sId, wbt)
{
  if (sId) { this.init(sId, wbt); }
}
SCORMAdapter.prototype.init = function(sId, wbt)
{
  	this.sId = sId;
  	this.initialized = false;
  	this.finished = false;
  	this.lessonStatus = "incomplete";
  	this.loginBaseURL = wbt;
  	this.quotedLoginBaseURL = "";
  	var vs = wbt.split('/');
  	for (var v in vs) {
  		this.quotedLoginBaseURL += vs[v];
  		this.quotedLoginBaseURL += "\/";
    }
  	HandleMap.instance.registerHandle(this.sId, this);
}
SCORMAdapter.prototype.getId = function()
{
  return this.sId;
}
SCORMAdapter.prototype.notifyAchievement = function(dFractionCorrect, dFractionDone,
				bCertificateConditionFulfilled)
{
	;
	if (this.initialized && !this.finished)
	{
		
		var score = dFractionCorrect * 100;
		score = score.toFixed(1);
        ;
		doLMSSetValue(LMS_SCORE, score);
		
		if (bCertificateConditionFulfilled == true
			&& this.lessonStatus != "passed" && this.lessonStatus != "browsed")
		{
			this.lessonStatus = "passed";
        	doLMSSetValue(LMS_STATUS, this.lessonStatus);
        }
		
		var formattedTime = this.computeTime();
		doLMSSetValue(LMS_SESSIONTIME, formattedTime );
		;
		var result = doLMSCommit();
		;
	}
}
SCORMAdapter.prototype.notifyFinish = function(timeout)
{
	;
	this.finished = true;
    self.setInterval(this.sId + "\.finishConnection();", timeout);
}
SCORMAdapter.prototype.notifyLocation = function(sLocation)
{
	;
	if (this.initialized && !this.finished)
	{
		
		if (sLocation != null && sLocation != "")
			doLMSSetValue(LMS_LOCATION, sLocation);
		var result = doLMSCommit();
	}
}
SCORMAdapter.prototype.notifyCBTImport = function(learningtime)
{
	;
	this.externalLearningTime = learningtime;
}
SCORMAdapter.prototype.finish = function()
{
	if (this.initialized == true && this.finished == false)
	{
    	this.finishConnection();
	}
}
SCORMAdapter.prototype.initConnection = function()
{
	var result = doLMSInitialize();
	if (result == "true")
	{
		this.initialized = true;
		
		var credit = doLMSGetValue(LMS_CREDIT);
		;
		
		this.lessonStatus = doLMSGetValue(LMS_STATUS);
		;
		if (this.lessonStatus != "browsed")
		{
	  		this.lessonStatus = "incomplete";
	  		doLMSSetValue( LMS_STATUS, this.lessonStatus );
	  	}
	  	
   		doLMSSetValue( LMS_SCORE_MIN, "0" );
   		doLMSSetValue( LMS_SCORE_MAX, "100" );
   		var scoremin =  doLMSGetValue( LMS_SCORE_MIN );
   		var scoremax =  doLMSGetValue( LMS_SCORE_MAX );
   		var result = doLMSCommit();
   		
   		this.initLMSUser();
	}
}
SCORMAdapter.prototype.initLMSUser = function()
{
	if (this.initialized)
	{
	 	var userID = doLMSGetValue(LMS_USER_ID);
    	var userName = doLMSGetValue(LMS_USER_NAME);
    	var lmsPlattform = "lmsplattform";
    	this.sendLMSUserInit(userID, userName, SCORMAdapter.ADAPTERTYPE , lmsPlattform);
	}
}
SCORMAdapter.prototype.login = function()
{
	if (this.initialized)
	{
    	var userID = doLMSGetValue(LMS_USER_ID);
    	var userName = doLMSGetValue(LMS_USER_NAME);
    	
    	var location =  doLMSGetValue(LMS_LOCATION);
    	if (location == null || "" == location)
    		location = "/";
    	var loginURL = this.loginBaseURL + location;
    	;
    	self.wbt.location.replace(loginURL);
    	this.startDate = new Date().getTime();
   		this.externalLearningTime = 0;
    }
}
SCORMAdapter.prototype.finishConnection = function()
{
	if (this.initialized == true)
	{
    	if (this.finished)
    		doLMSSetValue(LMS_EXIT, "" );
    	else
    		doLMSSetValue(LMS_EXIT, "suspend" );
    	var result = doLMSFinish();
	}
}
SCORMAdapter.prototype.computeTime = function()
{
   if ( this.startDate != 0 )
   {
      var currentDate = new Date().getTime();
      var elapsedSeconds = ( (currentDate - this.startDate) / 1000 ) + this.externalLearningTime;
      var formattedTime = convertTotalSeconds( elapsedSeconds );
   }
   else
   {
      formattedTime = "00:00:00.0";
   }
   return formattedTime;
}
function convertTotalSeconds(ts)
{
   var sec = (ts % 60);
   ts -= sec;
   var tmp = (ts % 3600);  
   ts -= tmp;              
   sec = Math.round(sec*100)/100;
   var strSec = new String(sec);
   var strWholeSec = strSec;
   var strFractionSec = "";
   if (strSec.indexOf(".") != -1)
   {
      strWholeSec =  strSec.substring(0, strSec.indexOf("."));
      strFractionSec = strSec.substring(strSec.indexOf(".")+1, strSec.length);
   }
   if (strWholeSec.length < 2)
   {
      strWholeSec = "0" + strWholeSec;
   }
   strSec = strWholeSec;
   if (strFractionSec.length)
   {
      strSec = strSec+ "." + strFractionSec;
   }
   if ((ts % 3600) != 0 )
      var hour = 0;
   else var hour = (ts / 3600);
   if ( (tmp % 60) != 0 )
      var min = 0;
   else var min = (tmp / 60);
   if ((new String(hour)).length < 2)
      hour = "0"+hour;
   if ((new String(min)).length < 2)
      min = "0"+min;
   var rtnVal = hour+":"+min+":"+strSec;
   return rtnVal;
}
SCORMAdapter.prototype.sendLMSUserInit = function(userId, userName, adapterType, plattform)
{
    var params = "?";
    params += SCORMAdapter.PARAM_LMS_USERID + "=";
    params += encodeURIComponent(userId) + "&";
    params += SCORMAdapter.PARAM_LMS_USERNAME + "=";
    params += encodeURIComponent(userName) + "&";
    params += SCORMAdapter.PARAM_LMS_ADAPTERTYPE + "=";
    params += encodeURIComponent(adapterType) + "&";
    params += SCORMAdapter.PARAM_LMS_PLATTFORM + "=";
    params += encodeURIComponent(plattform);
	var doc = '<HTML>';
	doc += '<HEAD>';
	doc += '<script type="text\/javascript" src="';
	doc += this.quotedLoginBaseURL;
	doc += 'lmsuserinit';
	doc += params;
	doc += '"><\/script>';
	doc += '<\/HEAD>';
	doc += '<body onload="parent\.' + this.sId + '\.login();">';
	doc += '<\/body>';
	doc += '<\/HTML>';
	self.pollframe.document.open();
	self.pollframe.document.write(doc);
	self.pollframe.document.close();
}
SCORMAdapter.prototype.initPollFrame = function()
{
	var doc = '<HTML>';
	doc += '<HEAD>';
	doc += '<script type="text\/javascript" src="';
	doc += this.quotedLoginBaseURL;
	doc += SCORMAdapter.PARAM_LMS2WBT;
	doc += '?channel=lms&msg_type=get'
	doc += '"><\/script>';
	doc += '<\/HEAD>';
	doc += '<BODY>';
	doc += '<\/BODY>';
	doc += '<\/HTML>';
	self.pollframe.document.open();
	self.pollframe.document.write(doc);
	self.pollframe.document.close();
}
