/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function QeaItem(sId, nMax)
{
  if (sId) { this.init(sId, nMax); }
}
QeaItem.prototype.init = function(sId, nMax)
{
  ;
  this.sId = sId;
  this.nMax = nMax;
  this.bSwapSingle = (this.nMax == 1);
  this.workItem = null; 
  this.bEvaluated = false;
  this.bSolved = false;
  this.lastEvaluation = null;
  this.nCorrectEvaluations = 0;
  this.bUncovered = false;
  this.bUserFocus = false; 
  this.aSCListener = new Array(); 
  this.nSCListener = 0;
}
QeaItem.prototype.getId = function()
{
  return this.sId;
}
QeaItem.prototype.hasUserFocus = function()
{
  return this.bUserFocus;
}
QeaItem.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
}
QeaItem.prototype.registerStatusChangeListener = function(scListener)
{
  ;
  if (this.aSCListener[scListener.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSCListener[scListener.getId()] = scListener;
    this.nSCListener++;
    ;
    scListener.setModelItem(this);
  }
  return null;
}
QeaItem.prototype.start = function()
{
  ;
}
QeaItem.prototype.canSetActive = function(bActive)
{
  ;
  var bCanSetActive = true;
  if (bActive == true)
  {
    var nCount = this.countActiveEvaluations()
    if (nCount >= this.nMax && !this.bSwapSingle)
    {
      ;
      bCanSetActive = false;
    }
  }
  return bCanSetActive;
}
QeaItem.prototype.assign = function(question, answer)
{
  ;
  return this.workItem.assign(question, answer);
}
QeaItem.prototype.assignByText = function(question, sText)
{
  ;
  return this.workItem.assignByText(question, sText);
}
QeaItem.prototype.assignOrConfirmByText = function(question, sText)
{
  ;
  return this.workItem.assignOrConfirmByText(question, sText);
}
QeaItem.prototype.assignByTextAndGridPos = function(question, sText, nX, nY)
{
  ;
  return this.workItem.assignByText(question, sText, nX, nY);
}
QeaItem.prototype.unassign = function(question, answer)
{
  ;
  return this.workItem.unassign(question, answer);
}
QeaItem.prototype.changedEvaluation = function(evaluation)
{
  ;
  this.bEvaluated = false;
  if (this.countCorrectEvaluations() == 0 && this.lastEvaluation && this.getComplementItem(evaluation) != this.getComplementOffItem())
  {
    if (evaluation.isActive())
    {
      if (this.getComplementOffItem() == this.getComplementItem(this.lastEvaluation))
      {
        ;
        var bManagerStatus = this.workItem.getNotifyManagers();
        this.workItem.setNotifyManagers(false);
        this.lastEvaluation.setActive(false, 'system_off');
        this.workItem.setNotifyManagers(bManagerStatus);
      }
    }
    else
    {
      if (this.countActiveEvaluations() == 0)
      {
        var bManagerStatus = this.workItem.getNotifyManagers();
        this.workItem.setNotifyManagers(false);
        this.activateOffEvaluation();
        this.workItem.setNotifyManagers(bManagerStatus);
      }
    }
  }
  if (evaluation.isActive())
  {
    if (this.nMax == 1 && this.bSwapSingle)
    {
      for (var id in this.workItem.aEvaluations)
      {
        var e = this.workItem.aEvaluations[id];
        if (e.isActive() && e != evaluation && this.getSameItem(e) == this)
        {
          ;
          e.setActive(false, 'system_swapsingle');
        }
      }
    }
  }
  this.lastEvaluation = evaluation;
  this.notify();
}
QeaItem.prototype.notify = function(evaluation)
{
  ;
  if (this.workItem.getNotifyView())
  {
    for (var id in this.aSCListener)
    {
      this.aSCListener[id].changed(this);
    }
  }
}
QeaItem.prototype.getSameItem = function(evaluation)
{
  ;
  return null;
}
QeaItem.prototype.getComplementItem = function(evaluation)
{
  ;
  return null;
}
QeaItem.prototype.getActiveEvaluations = function()
{
  ;
  var aEvaluations = new Array();
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (e.isActive() && this.getSameItem(e) == this && this.getComplementItem(e) != this.getComplementOffItem())
    {
      aEvaluations.push(e)
    }  
  }
  return aEvaluations;
}
QeaItem.prototype.countActiveEvaluations = function()
{
  ;
  var nCount = 0;
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (e.isActive() && this.getSameItem(e) == this && this.getComplementItem(e) != this.getComplementOffItem())
    {
      nCount++;
    }
  }
  ;
  return nCount;
}
QeaItem.prototype.countActiveCorrectEvaluations = function()
{
  ;
  var nCount = 0;
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (e.isActive() && e.isCorrect() && this.getSameItem(e) == this && this.getComplementItem(e) != this.getComplementOffItem())
    {
      nCount++;
    }
  }
  ;
  return nCount;
}
QeaItem.prototype.getActiveComplement = function()
{
  ;
  return this.getNextActiveComplement(null);
}
QeaItem.prototype.getNextActiveComplement = function(lastComplement)
{
  ;
  var nextComplement = null;
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (e.isActive() && this.getSameItem(e) == this && this.getComplementItem(e) != this.getComplementOffItem())
    {
      if (lastComplement == null)
      {
        nextComplement = this.getComplementItem(e);
        break;
      }
      else
      {
        if (this.getComplementItem(e) == lastComplement) { lastComplement = null; }
      }
    }
  }
  ;
  return nextComplement;
}
QeaItem.prototype.getSolutionComplement = function()
{
  ;
  return this.getNextSolutionComplement(null);
}
QeaItem.prototype.getNextSolutionComplement = function(lastComplement)
{
  ;
  var nextComplement = null;
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (e.isSolution() && this.getSameItem(e) == this && this.getComplementItem(e) != this.getComplementOffItem())
    {
      if (lastComplement == null)
      {
        nextComplement = this.getComplementItem(e);
        break;
      }
      else
      {
        if (this.getComplementItem(e) == lastComplement) { lastComplement = null; }
      }
    }
  }
  ;
  return nextComplement;
}
QeaItem.prototype.getMax = function()
{
  //;
  return this.nMax;
}
QeaItem.prototype.isSolved = function()
{
  //;
  return this.bSolved;
}
QeaItem.prototype.isEvaluated = function()
{
  //;
  return this.bEvaluated;
}
QeaItem.prototype.evaluated = function(bSolved)
{
  ;
  this.bSolved = bSolved;
  this.bEvaluated = true;
}
QeaItem.prototype.incCorrectEvaluations = function()
{
  ;
  this.nCorrectEvaluations++;
}
QeaItem.prototype.countCorrectEvaluations = function()
{
  //;
  return this.nCorrectEvaluations;
}
QeaItem.prototype.uncoverEvaluations = function()
{
  ;
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (this.getSameItem(e) == this)
    {
      e.setUncovered(true);
    }
  }
  this.setUncovered(true);
}
QeaItem.prototype.isUncovered = function()
{
  //;
  return this.bUncovered;
}
QeaItem.prototype.setUncovered = function(bUncovered)
{
  //;
  this.bUncovered = bUncovered;
}
QeaItem.prototype.checkUncovered = function()
{
  ;
  return this.isUncovered();
}
QeaItem.prototype.getEvaluation = function()
{
  //;
  return this.lastEvaluation;
}
QeaItem.prototype.match = function(sId)
{
  //;
  return false;
}
QeaItem.prototype.isAnswer = function()
{
  return false;
}
QeaItem.prototype.isQuestion = function()
{
  return false;
}
QeaItem.prototype.reset = function()
{
  ;
  this.bUncovered = false;
  this.bEvaluated = false;
  this.bSolved = false;
  this.bUserFocus = false;
}
