/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
</DEPENDENCIES>
*/
function BasicQeaTipStrategy(sId)
{
  if (sId) this.init(sId);
}
BasicQeaTipStrategy.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.bSolutable;
  this.workItem = null;
  this.aEvaluationIds = null;
  this.lastTippedEvaluation = null;
  this.bCanCycleTips = true; 
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'basic_qea_system_cycletip_sentinel'
  }
}
BasicQeaTipStrategy.prototype.getId = function()
{
  return this.sId;
}
BasicQeaTipStrategy.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
  this.nTips = 0; 
}
BasicQeaTipStrategy.prototype.start = function()
{
  ;
}
BasicQeaTipStrategy.prototype.hasShowTip= function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  if (bShow )
  {
    ;
  }
  this.bSolutable = bSolutable;
  var bHasTip = false;
  var aNewTippableEvaluations = new Array();
  var aAlreadyTippedEvaluations = new Array();
  var nIndexNew = 0;
  var nIndexAlready = 0;
  var bLastEvaluationIsTippable = false;
  if (this.lastTippedEvaluation != null)
  {
    if (this.evaluationHasTip(this.lastTippedEvaluation, bStepByStep))
    {
      var bLastEvaluationIsTippable = true;
      bHasTip = true;
    }
  }
  var bHasUndo = false;
  if ( bCycleTips && this.lastTippedEvaluation != null)
  {
    if ( this.workItem.qeaUndoStack.hasUndoSentinel(this.sCycleTipsUndoSentinel) )
    {
      bHasTip = true;
      if( bShow )
      {
        bHasUndo = true;
        var sentinel = this.workItem.undo(false, this.sCycleTipsUndoSentinel);
        if (sentinel != this.sCycleTipsUndoSentinel)
        {
          //;
        }
      }
    }    
  }
  if ( !bShow && !bHasTip)
  {
    if (  bCycleTips && this.lastTippedEvaluation )
    {
      if ( this.workItem.qeaUndoStack.hasUndoSentinel(this.sCycleTipsUndoSentinel) )
      {
        bHasTip = true;
      }
    }
  }
  if ( (!bShow && !bHasTip) || bShow)
  {
    if (bLastEvaluationIsTippable && 1)
    {
      aNewTippableEvaluations[nIndexNew++] = this.lastTippedEvaluation;
      bHasTip = true;
    }
    else
    {
      for (var id in this.workItem.aEvaluations)
      {
        var e = this.workItem.aEvaluations[id];
        if (this.evaluationHasTip(e, bStepByStep))
        {
          if (e.hasSystemContribution())
          {
            aAlreadyTippedEvaluations[nIndexAlready++] = e;
          }
          else
          {
            aNewTippableEvaluations[nIndexNew++] = e;
          }
        }
      }
    }
  }
  if ( (!bShow && !bHasTip) || bShow)
  {
    var aValidEvaluations = null;
    var nIndex = 0;
    if (nIndexNew > 0)
    {
      if (bSolutable)
      {
        aValidEvaluations = aNewTippableEvaluations;
        nIndex = nIndexNew;
      }
      else
      {
        this.workItem.setNotifyView(false);
        var bLocked = this.workItem.qeaUndoStack.isLocked();
        this.workItem.qeaUndoStack.setLock(false);
        shuffleArray(aNewTippableEvaluations);
        for (var i = 0; i < aNewTippableEvaluations.length; i++)
        {
          this.workItem.setUndoBreak('system_uncovertip_sentinel');
          this.evaluationShowTip(aNewTippableEvaluations[i], bStepByStep);
          var bUncovered = this.workItem.isUncovered();
          var bRestoreSystemContribution = true;
          var sentinel = this.workItem.undo(bRestoreSystemContribution, 'system_uncovertip_sentinel');
          if (sentinel != 'system_uncovertip_sentinel')
          {
            ;
          }
          if (!bUncovered)
          {
            aValidEvaluations = new Array();
            aValidEvaluations[nIndex++] = aNewTippableEvaluations[i];
            break;
          }
        }
        this.workItem.qeaUndoStack.setLock(bLocked);
        this.workItem.setNotifyView(true);
      }
      if (nIndex > 0)
      {
        ;
      }
    }
    else if (nIndexAlready > 0)
    {
      aValidEvaluations = aAlreadyTippedEvaluations;
      nIndex = nIndexAlready;
      ;
    }
  }
  if (nIndex == 0)
  {
    ;
  }
  else
  {
    ;
    bHasTip = true;
  }
  if (bShow && bHasTip)
  {
    var nRandomIndex = 0;
    if (bCycleTips)
    {
      nRandomIndex = this.nTips % nIndex; 
      if (aValidEvaluations[nRandomIndex] == this.lastTippedEvaluation)
      {
        nRandomIndex = (this.nTips+1) % nIndex; 
      }
    }
    else
    {
      var nLow = 0;
      var nHigh = nIndex - 1;
      nRandomIndex = Math.round( (nLow - 0.5) +( ( (nHigh+0.49999) - (nLow-0.5) ) * Math.random() ) );
    }
    var e = aValidEvaluations[nRandomIndex];
    if (! (bHasUndo && e == this.lastTippedEvaluation) )
    { 
      this.workItem.setUndoBreak(this.sCycleTipsUndoSentinel);
      this.evaluationShowTip(e, bStepByStep);
      this.lastTippedEvaluation = e;
    }
    this.nTips++;
  }
  return bHasTip;
}
BasicQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  return evaluation.isSolution() && !evaluation.isActive() && evaluation.canSetActive(true);
}
BasicQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(true, 'system_set');
}
ShowMissingQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
ShowMissingQeaTipStrategy.prototype.constructor = ShowMissingQeaTipStrategy;
ShowMissingQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function ShowMissingQeaTipStrategy(sId)
{
  this.init(sId)
}
ShowMissingQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'show_missing_qea_system_cycletip_sentinel'
  }
  ShowMissingQeaTipStrategy.superclass.init.call(this, sId);
}
ShowMissingQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(true);
  }
  if (bHasTip)
  {
    if (evaluation.getQuestion().getMax() == 1) 
    {
      if (evaluation.getQuestion().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  if (bHasTip)
  {
    if (evaluation.getAnswer().getMax() == 1) 
    {
      if (evaluation.getAnswer().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  return bHasTip;
}
ShowMissingQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(true, 'system_set');
}
ApproveCorrectQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
ApproveCorrectQeaTipStrategy.prototype.constructor = ApproveCorrectQeaTipStrategy;
ApproveCorrectQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function ApproveCorrectQeaTipStrategy(sId)
{
  this.init(sId)
}
ApproveCorrectQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'show_missing_qea_system_cycletip_sentinel'
  }
  ApproveCorrectQeaTipStrategy.superclass.init.call(this, sId);
}
ApproveCorrectQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isCorrect() && evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.getOrigin() == 'user';
  }
  return bHasTip;
}
ApproveCorrectQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(true, 'system_approve');
}
ApproveOffQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
ApproveOffQeaTipStrategy.prototype.constructor = ApproveOffQeaTipStrategy;
ApproveOffQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function ApproveOffQeaTipStrategy(sId)
{
  this.init(sId)
}
ApproveOffQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'approve_off_qea_system_cycletip_sentinel'
  }
  ApproveOffQeaTipStrategy.superclass.init.call(this, sId);
}
ApproveOffQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isCorrect() && evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.getOrigin() != 'system_approve';
  }
  if (bHasTip)
  {
    bHasTip = evaluation.hasOffItem();
  }
  return bHasTip;
}
ApproveOffQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(true, 'system_approve');
}
BrandWrongQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
BrandWrongQeaTipStrategy.prototype.constructor = BrandWrongQeaTipStrategy;
BrandWrongQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function BrandWrongQeaTipStrategy(sId)
{
  this.init(sId)
}
BrandWrongQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'brand_wrong_qea_system_cycletip_sentinel'
  }
  BrandWrongQeaTipStrategy.superclass.init.call(this, sId);
}
BrandWrongQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = !evaluation.isCorrect() && evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.getOrigin() != 'system_brand';
  }
  return bHasTip;
}
BrandWrongQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(true, 'system_brand');
}
RemoveWrongQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
RemoveWrongQeaTipStrategy.prototype.constructor = RemoveWrongQeaTipStrategy;
RemoveWrongQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function RemoveWrongQeaTipStrategy(sId)
{
  this.init(sId)
}
RemoveWrongQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'remove_wrong_qea_system_cycletip_sentinel'
  }
  RemoveWrongQeaTipStrategy.superclass.init.call(this, sId);
}
RemoveWrongQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = !evaluation.isCorrect() && evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(false);
  }
  return bHasTip;
}
RemoveWrongQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(false, 'system_unset');
}
CorrectWrongQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
CorrectWrongQeaTipStrategy.prototype.constructor = CorrectWrongQeaTipStrategy;
CorrectWrongQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function CorrectWrongQeaTipStrategy(sId)
{
  this.init(sId)
}
CorrectWrongQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'correct_wrong_qea_system_cycletip_sentinel'
  }
  CorrectWrongQeaTipStrategy.superclass.init.call(this, sId);
}
CorrectWrongQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isCorrect() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(true);
  }
  var wrongEval = null;
  if (bHasTip)
  {
    var question = evaluation.getQuestion();
    var answer = evaluation.getAnswer();
    var evaluations = evaluation.workItem.getEvaluations(question, answer);
    for(var i in evaluations)
    {
      if(evaluations[i] != evaluation)
      {
        wrongEval = evaluations[i];
        break;
      }
    }
    if ( ! wrongEval )
    {
      bHasTip = false;
    }
  }
  if (bHasTip)
  {
    bHasTip = wrongEval.isActive() && !wrongEval.isCorrect();
  }
  if (bHasTip)
  {
    if (! ( evaluation.getQuestion().getMax() == 1 || evaluation.getAnswer().getMax() == 1 )) 
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
CorrectWrongQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(true, 'system_set');
}
ShowFirstCharacterQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
ShowFirstCharacterQeaTipStrategy.prototype.constructor = ShowFirstCharacterQeaTipStrategy;
ShowFirstCharacterQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function ShowFirstCharacterQeaTipStrategy(sId)
{
  this.init(sId)
}
ShowFirstCharacterQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'show_first_character_qea_system_cycletip_sentinel'
  }
  ShowFirstCharacterQeaTipStrategy.superclass.init.call(this, sId);
}
ShowFirstCharacterQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (bHasTip)
  {
    var answer = evaluation.getQuestion().getActiveComplement();
    if (answer)
    {
      bHasTip = answer.getText() == '';
    }
  }
  return bHasTip;
}
ShowFirstCharacterQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var cFirstChar = evaluation.getAnswer().getText().charAt(0);
  var answer = this.workItem.getOrCreateAnswerByText(cFirstChar);
  var e = this.workItem.getOrCreateEvaluation(evaluation.getQuestion(), answer);
  e.setActive(true, 'system_set');
}
ShowMissingAnswerQeaTipStrategy.prototype             = new ShowMissingQeaTipStrategy();
ShowMissingAnswerQeaTipStrategy.prototype.constructor = ShowMissingAnswerQeaTipStrategy;
ShowMissingAnswerQeaTipStrategy.superclass            = ShowMissingQeaTipStrategy.prototype;
function ShowMissingAnswerQeaTipStrategy(sId)
{
  this.init(sId)
}
ShowMissingAnswerQeaTipStrategy.prototype.init = function(sId)
{
  ;
  ShowMissingAnswerQeaTipStrategy.superclass.init.call(this, sId);
}
ShowMissingAnswerQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  ShowMissingAnswerQeaTipStrategy.superclass.evaluationShowTip.call(this, evaluation, bStepByStep);
  var answer = evaluation.getAnswer();
  var aEvaluations = this.workItem.aEvaluations;
  for(var i in aEvaluations)
  {
    var e = aEvaluations[i];
    if(e.getAnswer() == answer)
    {
      if(ShowMissingAnswerQeaTipStrategy.superclass.evaluationHasTip.call(this, e, bStepByStep))
      {
        ShowMissingAnswerQeaTipStrategy.superclass.evaluationShowTip.call(this, e, bStepByStep);
      }
    }
  }
}
