/*
<DEPENDENCIES>
  <DEPENDS>Logger</DEPENDS>
	<DEPENDS>ProductFilter</DEPENDS>
</DEPENDENCIES>
*/
function SelectionValue(sId, valueId, valueName, active, empty)
{
	if (sId)
	{
		this.init(sId, valueId, valueName, active, empty);
	}
}
SelectionValue.prototype.init = function(sId, valueId, valueName, active, empty)
{
	;
	this.sId = sId;
	this.valueId = valueId;
	this.valueName = valueName;
	this.active = active;
	this.empty = empty;
	this.activeHandles = new Array();
	this.inactiveHandles = new Array();
	this.aSCListener = new Array();
	this.initialActive = active;
	this.manager = null;
}
SelectionValue.prototype.getId = function()
{
	return this.sId;
}
SelectionValue.prototype.start = function()
{
	this.setActive(this.initialActive, true);
}
SelectionValue.prototype.setManager = function(manager)
{
	this.manager = manager;
}
SelectionValue.prototype.getManager = function()
{
	return this.manager;
}
SelectionValue.prototype.getValueId = function()
{
	return this.valueId;
}
SelectionValue.prototype.getValue = function()
{
	return this.valueName;
}
SelectionValue.prototype.isDefaultValue = function()
{
	return this.initialActive;
}
SelectionValue.prototype.isEmpty = function()
{
	return this.empty;
}
SelectionValue.prototype.registerStatusChangeListener = function(scListener)
{
	if (this.aSCListener[scListener.getId()] != null)
	{
		;
	}
	else
	{
		//		;
		this.aSCListener[scListener.getId()] = scListener;
		scListener.setModelItem(this);
	}
	return null;
}
SelectionValue.prototype.notify = function()
{
	//	;
	for (var id in this.aSCListener)
	{
		this.aSCListener[id].changed(this);
	}
}
SelectionValue.prototype.set = function()
{
	//	;
	this.active = true;
	this.fireActive();
}
SelectionValue.prototype.getSetActiveAction = function()
{
	return new ObjectMethodAction(this, 'setActive', true);
}
SelectionValue.prototype.addActiveHandle = function(action)
{
	this.activeHandles.push(action);
}
SelectionValue.prototype.fireActive = function()
{
	for (var i = 0; i < this.activeHandles.length; i++)
	{
		this.activeHandles[i].invoke();
	}
}
SelectionValue.prototype.reset = function()
{
	this.setActive(this.initialActive, true);
}
SelectionValue.prototype.addInactiveHandle = function(action)
{
	this.inactiveHandles.push(action);
}
SelectionValue.prototype.getSetInactiveAction = function()
{
	return new ObjectMethodAction(this, 'setActive', false);
}
SelectionValue.prototype.fireInActive = function()
{
	for (var i = 0; i < this.inactiveHandles.length; i++)
	{
		this.inactiveHandles[i].invoke();
	}
}
SelectionValue.prototype.setActive = function(active, preventmanagernotify)
{
	//	;
	this.active = active;
	if (active == true)
	{
		this.fireActive();
	}
	else
	{
		this.fireInActive();
	}
	if (preventmanagernotify == undefined || preventmanagernotify == false)
	{
		if (this.manager != null)
			this.manager.process(this);
	}
}
SelectionValue.prototype.isActive = function()
{
	//	;
	return this.active;
}
SelectionValue.prototype.isInitialActive = function()
{
	return this.initialActive;
}
SelectionValueChangeable.prototype = new SelectionValue();
SelectionValueChangeable.prototype.constructor = SelectionValueChangeable;
SelectionValueChangeable.superclass = SelectionValue.prototype;
function SelectionValueChangeable(sId, valueId, valueName, active, changeIdAndValue)
{
	if (sId)
	{
		this.init(sId, valueId, valueName, active, changeIdAndValue);
	}
}
SelectionValueChangeable.prototype.init = function(sId, valueId, valueName, active, changeIdAndValue)
{
	SelectionValueChangeable.superclass.init.call(this, sId, valueId, valueName, active);
	this.changeIdAndValue = changeIdAndValue;
}
SelectionValueChangeable.prototype.getChangeValueAction = function()
{
	return new ObjectMethodAction(this, "changeValue");
}
SelectionValueChangeable.prototype.changeValue = function(value)
{
	this.valueName = value;
	if (this.changeIdAndValue)
		this.valueId = value;
	this.setActive(true);
}
