/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Sequence</DEPENDS>
    <DEPENDS>ExerciseHandlerStatus</DEPENDS>
</DEPENDENCIES>
*/
function SequenceWorkItem(sId) 
{
  if (sId) { this.init(sId); }
}
SequenceWorkItem.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.bIsShowSolutionActive = false; 
  this.bHasShownSolution = false; 
  this.aSequences = new Array();
  this.nSequences = 0;
  this.aSequenceItems = new Array();
  this.nSequenceItems = 0;
  this.oWorkItemBroker = null;
  this.workingSequence = new Sequence('workingSequence', false, false); 
  this.activeSequence = null;   
  this.startSequence = null;    
  this.solutionSequence = null; 
  this.beforeSolutionSequence = null; 
  this.aTipStrategies = new Array();
  this.nTipStrategies = 0;
  this.sOrigin = undefined;
  this.tipManager = null;
  this.excManager = null;
  this.visibilityBroker = null;
  this.bEvaluated = false;
  this.bActive = true;
  this.bNotifyView = true; 
  this.bNotifyManagers = true; 
  this.aSCListener = new Array(); 
  this.nSCListener = 0;
  this.bWorkStarted = false;
  this.bWorkStopped = false;
  this.bActivated = false;
  this.bSetStartSequence = false;
}
SequenceWorkItem.prototype.getId = function()
{
  return this.sId;
}
SequenceWorkItem.prototype.getNumCorrect = function()
{
  return this.solutionSequence.countSequenceItems();
}
SequenceWorkItem.prototype.getNumWrong = function()
{
  return this.nSequenceItems;
}
SequenceWorkItem.prototype.setWorkItemBroker = function(oWorkItemBroker)
{
  ;
  this.oWorkItemBroker = oWorkItemBroker;
  this.oWorkItemBroker.addResetHandle(this.getResetAction());
  this.oWorkItemBroker.addEvaluateHandle(this.getEvaluateAction());
  this.oWorkItemBroker.addNoticedHandle(this.getNoticedAction());
  this.oWorkItemBroker.addShowSolutionHandle(this.getShowSolutionAction());
  this.oWorkItemBroker.addHideSolutionHandle(this.getHideSolutionAction());
}
SequenceWorkItem.prototype.registerSequence = function(sequence)
{
  ;
  if (this.aSequences[sequence.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSequences[sequence.getId()] = sequence;
    this.nSequences++;
    ;
    sequence.setWorkItem(this);
  }
  if (sequence.isSolution())
  {
    this.solutionSequence = sequence;
  }
}
SequenceWorkItem.prototype.registerSequenceItem = function(sequenceItem)
{
  ;
  if (this.aSequenceItems[sequenceItem.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSequenceItems[sequenceItem.getId()] = sequenceItem;
    this.nSequenceItems++;
    ;
    sequenceItem.setWorkItem(this);
  }
}
SequenceWorkItem.prototype.registerTipStrategy = function(tipStrategy)
{
  ;
  if (this.aTipStrategies[tipStrategy.getId()] != null)
  {
    ;
  }
  else
  {
    this.aTipStrategies[tipStrategy.getId()] = tipStrategy;
    this.nTipStrategies++;
    ;
    tipStrategy.setWorkItem(this);
  }
}
SequenceWorkItem.prototype.registerStatusChangeListener = function(scListener)
{
  ;
  if (this.aSCListener[scListener.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSCListener[scListener.getId()] = scListener;
    this.nSCListener++;
    ;
    scListener.setModelItem(this);
  }
  return null;
}
SequenceWorkItem.prototype.setTipManager = function(tipManager)
{
  ;
  this.tipManager = tipManager;
}
SequenceWorkItem.prototype.setExerciseManager = function(excManager)
{
  ;
  this.excManager = excManager;
}
SequenceWorkItem.prototype.setVisibilityBroker = function(broker)
{
  ;
  this.visibilityBroker = broker;
}
SequenceWorkItem.prototype.setActive = function(bActive)
{
  ;
  this.bActive = bActive;
  if (this.tipManager) this.tipManager.changed(this);
}
SequenceWorkItem.prototype.getActivateAction = function()
{
  return new ObjectMethodAction(this, 'setActive', true);
}
SequenceWorkItem.prototype.getDeactivateAction = function()
{
  return new ObjectMethodAction(this, 'setActive', false);
}
SequenceWorkItem.prototype.start = function()
{
  ;
  if (!this.solutionSequence)
  {
    ;
  }
  if (this.startSequence)
  {
    this.bSetStartSequence = true;
    this.setSequence(this.startSequence);
    this.bSetStartSequence = false;
  }
  else
  {
    ;
  }
}
SequenceWorkItem.prototype.hasShowTip = function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  ;
  var bHasTip = false;
  for (var id in this.aTipStrategies)
  {
    var tipStrategy = this.aTipStrategies[id];
    if (tipStrategy)
    {
      ;
      if (bHasTip = tipStrategy.hasShowTip(bShow, bStepByStep, bSolutable, bCycleTips))
      {
        ;
        break;
      }
    }
  }
  if (!bHasTip) {
    ;
  }
  return bHasTip;
}
SequenceWorkItem.prototype.hasTip = function(bStepByStep, bSolutable, bCycleTips)
{
  ;
  if (this.bActive)
  {
    return this.hasShowTip(false, bStepByStep, bSolutable, bCycleTips);
  }
  else
  {
    return false;
  }
}
SequenceWorkItem.prototype.showTip = function(bStepByStep, bSolutable, bCycleTips)
{
  ;
  if (this.bActive)
  {
    var bHasTip = true;
    var bLocalCycleTips = bCycleTips;
    if (!bStepByStep)
    {
      bLocalCycleTips = false;
    }
    while (bHasTip)
    {
      bHasTip = this.hasShowTip(true, bStepByStep, bSolutable, bLocalCycleTips);
      this.bUserAction = false; 
      if (bStepByStep)
      {
        break; 
      }
    }
  }
  return bHasTip;
}
SequenceWorkItem.prototype.changed = function(sOrigin)
{
  ;
  if (this.bNotifyView)
  {
    if(sOrigin)
    {
        this.sOrigin = sOrigin;
    }
    else
    {
        this.sOrigin = 'user';
    }
    if( !this.bSetStartSequence && !this.bIsShowSolutionActive )
    {
        if (this.bNotifyManagers)
        {
          if( !this.bWorkStarted && !this.bEvaluated )
          {
            if( this.bHasShownSolution )
            {
              this.bHasShownSolution = false;
            }
            else
            {
              this.workStarted();
            }
          }
        }
        this.propagateStatus();
    }
    for (var id in this.aSCListener)
    {
      this.aSCListener[id].changed(this);
    }
  }
}
SequenceWorkItem.prototype.workStarted = function()
{
  if(!this.bWorkStarted)
  {
    this.noticed();
    this.bWorkStarted = true;
    if ( this.oWorkItemBroker )
    {
      this.oWorkItemBroker.doWorkStarted();
    }
    this.excManager.workItemStarted(this);
  }
}
SequenceWorkItem.prototype.propagateStatus = function()
{
  ;
  if (this.bNotifyManagers)
  {
    var excStatus = this.getExerciseStatus();
    ;
    if (this.excManager) this.excManager.solved(this, excStatus);
    if (this.tipManager) this.tipManager.changed(this);
    if (this.oWorkItemBroker)
    {
      this.oWorkItemBroker.solved(excStatus);
      if ( !this.bHelpApplied && (excStatus.nCorrectSystem || excStatus.nWrongSystem) )
      {
        this.bHelpApplied = true;
        this.oWorkItemBroker.doHelpApplied(); 
      }
    }
    if (this.visibilityBroker) this.visibilityBroker.activity();
  }
}
SequenceWorkItem.prototype.getExerciseStatus = function()
{
  ;
  var nCorrectTotal = 0;
  var nWrongTotal = 0;
  var nCorrectStatus = 0;
  var nWrongStatus = 0;
  var nCorrectSystem = 0;
  var nWrongSystem = 0;
  if (this.activeSequence && this.activeSequence.isCorrect())
  {
    nCorrectTotal = this.activeSequence.countSequenceItems();
    nWrongTotal = this.nSequenceItems;
    nCorrectStatus = this.activeSequence.countSequenceItems();
    nWrongStatus = 0;
  }
  else
  {
    nCorrectTotal = this.solutionSequence.countSequenceItems();
    nWrongTotal = this.nSequenceItems;
    nCorrectStatus = this.workingSequence.countMatchingSequenceItems(this.solutionSequence);
    nWrongStatus = this.workingSequence.countSequenceItems() - nCorrectStatus;
  }
  for (var id in this.aSequenceItems)
  {
    var item = this.aSequenceItems[id];
    if (item.hasSystemConstuction())
    {
      nCorrectSystem++;
    }
    if (item.hasSystemCorrection())
    {
      nWrongSystem++;
    }
  }
  if( !this.bWorkStarted )
  {
    return new ExerciseHandlerStatus(nCorrectTotal, nWrongTotal, 0, 0, 0, 0, this);
  }
  else
  {
    return new ExerciseHandlerStatus(nCorrectTotal, nWrongTotal, nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem, this, this.sOrigin);
  }
}
SequenceWorkItem.prototype.workStopped = function()
{
  ;
  if ( this.oWorkItemBroker && ! this.bWorkStopped)
  {
    this.oWorkItemBroker.doWorkStopped();
  }
  this.excManager.workItemStopped(this);
  this.bWorkStopped = true;
}
SequenceWorkItem.prototype.evaluate = function()
{
  ;
  this.workStarted();
  this.bEvaluated = true;
  this.changed();
  this.workStopped();
  var compareSequence = null;
  if (this.activeSequence.isCorrect())
  {
    compareSequence = this.activeSequence;
  }
  else
  {
    compareSequence = this.solutionSequence;
  }
  var sequenceItem = null;
  var nPos = null;
  for (var id in this.aSequenceItems)
  {
    sequenceItem = this.aSequenceItems[id]
    var nPos = this.workingSequence.getPositionOfSequenceItem(sequenceItem)
     sequenceItem.bEvaluated=true;
     if (compareSequence.getSequenceItemAtPosition(nPos).compare(sequenceItem))
     {
       sequenceItem.changed('evaluates_correct');
     }
     else
     {
       sequenceItem.changed('evaluates_wrong');
     }
  }
  this.activeSequence.evaluate();
  this.propagateStatus();
}
SequenceWorkItem.prototype.isEvaluated = function()
{
  return this.bEvaluated;
}
SequenceWorkItem.prototype.isSolved = function()
{
  return this.activeSequence.isCorrect();
}
SequenceWorkItem.prototype.isUncovered = function()
{
  ;
  var bIsUncovered = false;
  return bIsUncovered;
}
SequenceWorkItem.prototype.showSolution = function()
{
  ;
  this.bIsShowSolutionActive = true;
  this.beforeSolutionSequence = this.activeSequence;
  var sequenceItem = null;
  while ((sequenceItem = this.solutionSequence.getNextSequenceItem(sequenceItem)) != null)
  {
     if ( this.bEvaluated )
     {
       sequenceItem.bEvaluated = false;
     }
     sequenceItem.changed('system_solution');
  }
  this.workingSequence.copySequenceList(this.solutionSequence);
  this.setActiveSequence('system_solution');
  this.dumpStatus();
}
SequenceWorkItem.prototype.hideSolution = function()
{
  ;
  var sequenceItem = null;
  while((sequenceItem = this.solutionSequence.getNextSequenceItem(sequenceItem)) != null)
  {
    sequenceItem.changed('system_solution');
  }
  if (this.beforeSolutionSequence)
  {
    this.setSequence(this.beforeSolutionSequence, 'user');
    this.beforeSolutionSequence = null;
  }
  else
  {
    ;
  }
  if ( this.bEvaluated )
  {
    this.evaluate();
  }
  if( this.bIsShowSolutionActive )
  {
    this.bIsShowSolutionActive = false;
    this.bHasShownSolution = true;
  }
  this.dumpStatus();
}
SequenceWorkItem.prototype.dumpStatus = function()
{
  ;
  ;
  ;
  ;
  ;
  for(var id in this.aSequences)
  {
    ;
  }
  for(var id in this.aSequenceItems)
  {
    ;
  }
}
SequenceWorkItem.prototype.setNotifyView = function(bNotifyView)
{
  //;
  this.bNotifyView = bNotifyView;
}
SequenceWorkItem.prototype.getNotifyView = function()
{
  //;
  return this.bNotifyView;
}
SequenceWorkItem.prototype.setNotifyManagers = function(bNotifyManagers)
{
  //;
  this.bNotifyManagers = bNotifyManagers;
}
SequenceWorkItem.prototype.getNotifyManagers = function()
{
  //;
  return this.bNotifyManagers;
}
SequenceWorkItem.prototype.reset = function()
{
  ;
  if ( this.oWorkItemBroker && this.bWorkStarted && !this.bWorkStopped ) 
  {
    this.oWorkItemBroker.doWorkAborted();
  }
  this.excManager.workItemAborted(this);
  this.bNotifyManagers = false;
  this.bNotifyView = true;
  this.bEvaluated = false;
  for (var id in this.aSequences)
  {
    this.aSequences[id].reset();
  }
  for(var id in this.aSequenceItems)
  {
    this.aSequenceItems[id].reset();
  }
  this.bNotifyManagers = true;
  if (this.startSequence)
  {
    this.bSetStartSequence = true;
    this.setSequence(this.startSequence);
    this.bSetStartSequence = false;
  }
  this.bWorkStarted = false;
  this.bHelpApplied = false;
  this.bWorkStopped = false;
  this.propagateStatus();
}
SequenceWorkItem.prototype.setStartSequence = function(sequence)
{
  ;
  this.startSequence = sequence;
}
SequenceWorkItem.prototype.setSequence = function(sequence, sOrigin)
{
  ;
  this.workingSequence.copySequenceList(sequence);
  var sequenceItem = null;
  while ((sequenceItem = this.workingSequence.getNextSequenceItem(sequenceItem)) != null)
  {
    sequenceItem.changed(sOrigin);
  }
  this.setActiveSequence(sOrigin);
}
SequenceWorkItem.prototype.getSequence = function()
{
  ;
  return this.workingSequence;
}
SequenceWorkItem.prototype.addLastSequenceItem = function(sequenceItem, sOrigin)
{
  ;
  this.workingSequence.addLastSequenceItem(sequenceItem);
  sequenceItem.changed(sOrigin);
  this.setActiveSequence(sOrigin);
}
SequenceWorkItem.prototype.addFirstSequenceItem = function(sequenceItem, sOrigin)
{
  ;
  this.workingSequence.addFirstSequenceItem(sequenceItem, sOrigin);
  sequenceItem.changed(sOrigin);
  this.setActiveSequence(sOrigin);
}
SequenceWorkItem.prototype.removeSequenceItem = function(sequenceItem, sOrigin)
{
  ;
  var bFound = false;
  bFound= this.workingSequence.removeSequenceItem(sequenceItem, sOrigin);
  sequenceItem.changed(sOrigin);
  this.setActiveSequence(sOrigin);
  return bFound;
}
SequenceWorkItem.prototype.insertSequenceItemAtPosition = function(sequenceItem, nPosition, sOrigin)
{
  ;
  this.workingSequence.insertSequenceItemAtPosition(sequenceItem, nPosition, sOrigin);
  sequenceItem.changed(sOrigin);
  this.setActiveSequence(sOrigin);
}
SequenceWorkItem.prototype.moveSequenceItemAtPosition = function(sequenceItem, nPosition, sOrigin)
{
  ;
  this.workingSequence.removeSequenceItem(sequenceItem, sOrigin);
  this.workingSequence.insertSequenceItemAtPosition(sequenceItem, nPosition, sOrigin);
  sequenceItem.changed(sOrigin);
  this.setActiveSequence(sOrigin);
}
SequenceWorkItem.prototype.getPositionOfSequenceItem = function(sequenceItem)
{
  ;
  return this.workingSequence.getPositionOfSequenceItem(sequenceItem);
}
SequenceWorkItem.prototype.setActiveSequence = function(sOrigin)
{
  ;
  if (this.activeSequence) this.activeSequence.setActive(false, sOrigin);
  this.activeSequence = this.getOrCreateSequence();
  this.activeSequence.setActive(true, sOrigin);
  this.changed(sOrigin);
}
SequenceWorkItem.prototype.getOrCreateSequence = function()
{
  ;
  var sequence = null;
  for (var id in this.aSequences)
  {
    if (this.workingSequence.match(this.aSequences[id]))
    {
      sequence = this.aSequences[id];
      break;
    }
  }
  if (!sequence)
  {
    sequence = new Sequence('seq_' + this.getId() + '_' + this.nSequences, false, false);
    sequence.copySequenceList(this.workingSequence);
    this.registerSequence(sequence);
    ;
  }
  return sequence;
}
SequenceWorkItem.prototype.noticed = function()
{
  if(!this.bActivated)
  {
    this.bActivated = true;
    if(this.oWorkItemBroker)
    {
      this.oWorkItemBroker.activated();
    }
    this.excManager.workItemActivated(this);
  }
}
SequenceWorkItem.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, "reset");
}
SequenceWorkItem.prototype.getEvaluateAction = function()
{
  return new ObjectMethodAction(this, "evaluate");
}
SequenceWorkItem.prototype.getShowSolutionAction = function()
{
  return new ObjectMethodAction(this, "showSolution");
}
SequenceWorkItem.prototype.getHideSolutionAction = function()
{
  return new ObjectMethodAction(this, "hideSolution");
}
SequenceWorkItem.prototype.getNoticedAction = function()
{
  return new ObjectMethodAction(this, "noticed");
}
