/*
<DEPENDENCIES>
	<DEPENDS>Logger</DEPENDS>
	<DEPENDS>Actions</DEPENDS>
	<DEPENDS>LocationService</DEPENDS>
	<DEPENDS>LMSSuspendDataSerializer</DEPENDS>
</DEPENDENCIES>
*/
function LMSConnectorManagerAICC()
{
	;
	this.suspendDataSerializer = null;
	this.startDate = 0;
	this.structureName = null;
	this.achievementService = null;
	this.structureService = null;
	this.evaluationService = null;
	this.locationService = null;
	this.connected = false;
	this.sessionIdentifier = null;	
	this.lmsurl = null;
	this.score = new ScoreStatistics(0,0,0,0,1);
	this.sessiontime = '00:00:00.0';
	this.sessionstatus = 'I';	
	this.finished = false;  
	this.suspended = false;	
}
LMSConnectorManagerAICC.COMMAND_PUTPARAM = "?command=PutParam";
LMSConnectorManagerAICC.COMMAND_GETPARAM = "?command=GetParam";
LMSConnectorManagerAICC.COMMAND_EXIT = "?command=ExitAU";
LMSConnectorManagerAICC.AICC_DATA = "AICC_data=";
LMSConnectorManagerAICC.INIT_SID = "aicc_sid";
LMSConnectorManagerAICC.INIT_LMSURL = "aicc_url";
LMSConnectorManagerAICC.PUT_GROUP_CORE = "[Core]";
LMSConnectorManagerAICC.PUT_CORE_LESSON_LOCATION = "Lesson_Location";
LMSConnectorManagerAICC.PUT_CORE_LESSON_STATUS = "Lesson_Status";
LMSConnectorManagerAICC.PUT_CORE_SCORE = "Score";
LMSConnectorManagerAICC.PUT_CORE_SESSIONTIME = "Time";
LMSConnectorManagerAICC.PUT_GROUP_SUSPEND = "[Core_Lesson]"; 
LMSConnectorManagerAICC.prototype.start= function() {
	
	serviceregistry.registerService('lmsconnector', this);
}
LMSConnectorManagerAICC.prototype.initConnector= function() {
	if (this.locationService.isInitialized()
		&& this.achievementService.isInitialized()
		&& this.propertyService.isInitialized()
		&& this.linkService.isInitialized()
		)
    {
    	var url = parent.location.href;
		;
		var keyvalues = this.parseURL(url);
		
		var sessionid = keyvalues[LMSConnectorManagerAICC.INIT_SID];
		
		var lmsurl = keyvalues[LMSConnectorManagerAICC.INIT_LMSURL];
		if (sessionid && lmsurl)
		{
			this.sessionIdentifier = '&version=' + encodeURIComponent('4.0') + '&session_id=' + sessionid;
			this.lmsurl = decodeURIComponent(lmsurl);
			var sendcommand = this.lmsurl + LMSConnectorManagerAICC.COMMAND_GETPARAM + this.sessionIdentifier
				+ "&" + LMSConnectorManagerAICC.AICC_DATA;
			this.send(sendcommand, new ObjectMethodAction(this, 'parseGetParameter'));
		}
    }
}
LMSConnectorManagerAICC.prototype.parseGetParameter= function(xmldoc) {
	;
	var block = 0;
	if (xmldoc)
	{
		var parts = xmldoc.split('\r\n');
		for (var i=0; i < parts.length; i++)
		{
            var mypart = this.trim(parts[i]);
            if (mypart.indexOf('[') > -1)
            {
            	
            	mypart = mypart.toLowerCase();  
                ;
                if (mypart.indexOf('[core]') > -1)
               		block = 1;
               	else if (mypart.indexOf('[core_lesson]') > -1)
               		block = 2;
               	else if (mypart.indexOf('[core_vendor]') > -1)
               		block = 3;
            }
            else if (block == 1) 
            	this.checkCoreLessonBlockElement(mypart);
            else if (block == 2) 
            	this.checkCoreDataBlockElement(mypart);
		}
	}
	
	this.startDate = new Date().getTime(); 
	this.connected = true;
	this.startWBT();
}
LMSConnectorManagerAICC.prototype.checkCoreDataBlockElement= function(element)
{
	;
	if (element && element != '')
	{
        this.deserializeSuspendData(element);
	}
}
LMSConnectorManagerAICC.prototype.checkCoreLessonBlockElement= function(element) {
	if (element)
	{
		element = this.trim(element);
		var keyvalue = element.split('=');
		if (keyvalue && keyvalue.length==2)
		{
			var key = keyvalue[0].toLowerCase();
			if (key)
				this.trim(key);
			var value = keyvalue[1];
			if (value)
				this.trim(value);
			if (key == "lesson_location")
			{
				if (value)
				{
					
					var lastloc = decodeURIComponent(value);
					this.setInitialLastVisitedLocation(lastloc);
				}
			}
		}
	}
}
LMSConnectorManagerAICC.prototype.startWBT = function()
{
	var startloc = this.locationService.getStartLocation();
    parent.frames['mainframe'].location.replace(startloc);
}
LMSConnectorManagerAICC.prototype.parsePutParameter= function(xmldoc) {
	;
}
LMSConnectorManagerAICC.prototype.setStructureName= function(structureName) {
	;
	this.structureName = structureName;
}
LMSConnectorManagerAICC.prototype.setAchievementService= function(achievementService) {
	;
	this.achievementService = achievementService;
	
   	this.achievementService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerAICC.prototype.setStructureService= function(structureService) {
	;
	this.structureService = structureService;
}
LMSConnectorManagerAICC.prototype.setEvaluationService= function(evaluationService) {
	;
	this.evaluationService = evaluationService;
}
LMSConnectorManagerAICC.prototype.setLocationService= function(locationService) {
	;
	this.locationService = locationService;
	
	this.locationService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerAICC.prototype.setPropertyService= function(propertyService) {
	;
	this.propertyService = propertyService;
	
	this.propertyService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerAICC.prototype.setLinkService= function(linkService) {
	;
	this.linkService = linkService;
	
	this.linkService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerAICC.prototype.finishConnection= function() {
	;
	if (this.connected)
	{
		this.connected = false;
		if (!this.finished)
		{
			this.suspended = true;
			
			this.sendData();
		}
		
		var sendcommand =   this.lmsurl + LMSConnectorManagerAICC.COMMAND_EXIT + this.sessionIdentifier
			+ "&" + LMSConnectorManagerAICC.AICC_DATA;
		this.send(sendcommand, null);
	}
}
LMSConnectorManagerAICC.prototype.notifyFinished= function(timeout) {
	;
	this.finished = true;
}
LMSConnectorManagerAICC.prototype.retrieveAchievementData= function() {
	;
	var root = this.structureService.getRoot(this.structureName);
	if (root)
	{
		var myscore = this.achievementService.getScoreStatisticsTrace(this.structureName, root.getContentId());
		if (myscore)
			this.score = myscore;
	}
}
LMSConnectorManagerAICC.prototype.setLastVisitedLocation= function(folderId, entryId) {
	if (entryId)
	{
		var folder =
		        this.structureService.getStructureEntry(this.structureName, folderId);
		var structureEntry =
				this.structureService.getStructureEntry(this.structureName, entryId);
		if (folder && structureEntry)
		{
			this.locationService.setLastVistedLocation(folder, structureEntry);
		}
		else if (structureEntry)
		{
			
			this.locationService.setInitialLastVisitedLocation(structureEntry.getURL());
		}
	}
}
LMSConnectorManagerAICC.prototype.setInitialLastVisitedLocation= function(url) {
	if (url)
	{
		this.locationService.setInitialLastVisitedLocation(url);
	}
}
LMSConnectorManagerAICC.prototype.sendData= function() {
	;
	
	
	var mydata = LMSConnectorManagerAICC.PUT_GROUP_CORE + '\r\n';
	mydata = mydata + this.createScoreData() + '\r\n';
	mydata = mydata + this.createLocationData() + '\r\n';
	mydata = mydata + this.createLessonStatusData() + '\r\n';
	mydata = mydata + this.createSessiontimeData() + '\r\n';
	
	mydata = mydata + LMSConnectorManagerAICC.PUT_GROUP_SUSPEND + '\r\n';
	mydata = mydata + this.serializeSuspendData() + '\r\n';
	mydata = encodeURIComponent(mydata);
	var sendcommand =   this.lmsurl + LMSConnectorManagerAICC.COMMAND_PUTPARAM
		+ this.sessionIdentifier + '&'
		+ LMSConnectorManagerAICC.AICC_DATA + mydata;
	this.send(sendcommand, new ObjectMethodAction(this, 'parsePutParameter'));
	
	
	
	
	
	
	this.startDate = new Date().getTime();
	if (this.finished)
		this.finishConnection();
}
LMSConnectorManagerAICC.prototype.getSuspendDataSerializer = function()
{
	if (this.suspendDataSerializer == null)
		this.suspendDataSerializer =
				new LMSSuspendDataSerializer(this.evaluationService, this.locationService, this.structureName, this.structureService);
	return this.suspendDataSerializer;
}
LMSConnectorManagerAICC.prototype.serializeSuspendData = function()
{
	return this.getSuspendDataSerializer().serializeSuspendData();
}
LMSConnectorManagerAICC.prototype.deserializeSuspendData = function(serializeddata)
{
	this.getSuspendDataSerializer().deserializeSuspendData(serializeddata);
}
LMSConnectorManagerAICC.prototype.createScoreData= function() {
	;
	var scoreraw = this.score.getFractionCorrect() * 100;
	scoreraw = Math.round(scoreraw);
	var scoremin = 0;
	var scoremax = 100;
	var scoredata = LMSConnectorManagerAICC.PUT_CORE_SCORE + "=" + scoreraw + ","
		+ scoremax + "," + scoremin;
	return scoredata;
}
LMSConnectorManagerAICC.prototype.createLocationData= function() {
	;
	var lastloc = '';
	if (this.locationService.hasLastVistedLocation())
	{
		lastloc = this.locationService.getLastVistedLocation();
	    lastloc = encodeURIComponent(lastloc);
	}
	return LMSConnectorManagerAICC.PUT_CORE_LESSON_LOCATION + "=" + lastloc;
}
LMSConnectorManagerAICC.prototype.createLessonStatusData= function() {
	;
	var mystatus = LMSConnectorManagerAICC.PUT_CORE_LESSON_STATUS + "=" + this.sessionstatus;
	if (this.finished)
		mystatus = mystatus;
	else if (this.suspended)
		mystatus = mystatus + ', S'; 
	return mystatus;
}
LMSConnectorManagerAICC.prototype.createSessiontimeData= function() {
	var mytime = this.computeTime();
	
	var mytimeparts = mytime.split('.');
	if (mytimeparts && mytimeparts.length==2)
		mytime = mytimeparts[0];
	;
	return LMSConnectorManagerAICC.PUT_CORE_SESSIONTIME + "=" + mytime;
}
LMSConnectorManagerAICC.prototype.send = function (url, action) {
	var request; 
    if (window.ActiveXObject)
    {
    	request = new ActiveXObject('Microsoft.XMLHTTP');
    }
    else
    {
    	request = new XMLHttpRequest;
        request.overrideMimeType("text/xml");
    }
    if (request)
    {
    	try
    	{
    		 request.open('GET',url,false);
             request.send('');
             if (action)
    			action.invoke(request.responseText);
    	}
    	catch (e)
    	{
    		if (action)
    			action.invoke('');
    	}
    }
}
LMSConnectorManagerAICC.prototype.sendWithXMLDoc = function (url, action) {
	if (document.implementation && document.implementation.createDocument) {
		var xmldoc = document.implementation.createDocument("", "", null);
		xmldoc.onload = function() {
			if (action)
				action.invoke(xmldoc);
		}
		xmldoc.load(url);
	} else if (window.ActiveXObject) {
		var xmldoc = new ActiveXObject("Microsoft.XMLDOM");
		xmldoc.onreadystatechange = function () {
			if (xmldoc.readyState == 4)
			{
				if (action)
					action.invoke(xmldoc);
			}
		}
		xmldoc.load(url);
	}
}
LMSConnectorManagerAICC.prototype.parseURL= function(url) {
	;
	var values = new Array();
	if (url)
	{
		var par = url.split('?');
		if (par &&  par.length==2)
		{
			var parameter = par[1].split('&');
			for (var i = 0; i < parameter.length; i++)
			{
				var keyvalue = parameter[i].split('=');
				if 	(keyvalue && keyvalue.length == 2)
				{
					values[keyvalue[0].toLowerCase()] = keyvalue[1];
				}
			}
		}
	}
	return values;
}
LMSConnectorManagerAICC.prototype.computeTime = function()
{
   if ( this.startDate != 0 )
   {
      var currentDate = new Date().getTime();
      var elapsedSeconds = (currentDate - this.startDate) / 1000;
      var formattedTime = this.convertTotalSeconds( elapsedSeconds );
   }
   else
   {
      formattedTime = "00:00:00.0";
   }
   return formattedTime;
}
LMSConnectorManagerAICC.prototype.convertTotalSeconds =  function (ts)
{
   var sec = (ts % 60);
   ts -= sec;
   var tmp = (ts % 3600);  
   ts -= tmp;              
   sec = Math.round(sec*100)/100;
   var strSec = new String(sec);
   var strWholeSec = strSec;
   var strFractionSec = "";
   if (strSec.indexOf(".") != -1)
   {
      strWholeSec =  strSec.substring(0, strSec.indexOf("."));
      strFractionSec = strSec.substring(strSec.indexOf(".")+1, strSec.length);
   }
   if (strWholeSec.length < 2)
   {
      strWholeSec = "0" + strWholeSec;
   }
   strSec = strWholeSec;
   if (strFractionSec.length)
   {
      strSec = strSec+ "." + strFractionSec;
   }
   if ((ts % 3600) != 0 )
      var hour = 0;
   else var hour = (ts / 3600);
   if ( (tmp % 60) != 0 )
      var min = 0;
   else var min = (tmp / 60);
   if ((new String(hour)).length < 2)
      hour = "0"+hour;
   if ((new String(min)).length < 2)
      min = "0"+min;
   var rtnVal = hour+":"+min+":"+strSec;
   return rtnVal;
}
LMSConnectorManagerAICC.prototype.trim = function(inputString) {
   if (typeof inputString != "string") { return inputString; }
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
   while (ch == " ") { 
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length-1, retValue.length);
   while (ch == " ") { 
      retValue = retValue.substring(0, retValue.length-1);
      ch = retValue.substring(retValue.length-1, retValue.length);
   }
   while (retValue.indexOf("  ") != -1) { 
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ")+1, retValue.length); 
   }
   return retValue; 
}
