/*
<DEPENDENCIES>
	<DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function LMSSuspendDataSerializer(evaluationService, locationService, structureName, structureService)
{
	;
	this.evaluationService = evaluationService;
	this.locationService = locationService;
	this.structureName = structureName;
	this.structureService = structureService;
}
LMSSuspendDataSerializer.prototype.serializeSuspendData = function()
{
	var suspenddata = '';
	
	var entries = this.evaluationService.getAllEvaluationEntries();
	for (var i = 0; i < entries.length; i++)
	{
		var entry = entries[i];
		
		if (entry.hasData())
			suspenddata = suspenddata + 'x' + i + '_' + entry.getData().getSerialized();
	}
	suspenddata = suspenddata + 'z'; 
	var locations = this.locationService.getAllLastVisitedLocations();
	for (var i = 0; i < locations.length; i++)
	{
		var entry = locations[i];
		suspenddata = suspenddata + 'x' + entry.getSerialized();
	}
	return suspenddata;
}
LMSSuspendDataSerializer.prototype.deserializeSuspendData = function(serializeddata)
{
	if (serializeddata && serializeddata != '')
	{
		
		
		serializeddata = serializeddata + '';
		serializeddata = this.trim(serializeddata);
		
		var data = serializeddata.replace(/_/g, ',');
		var data = data.replace(/t/g, 'true');
		var data = data.replace(/f/g, 'false');
		var blocks = data.split('z');
		if (blocks.length == 0)
		{
			
			this.deserializeEvaluationData(data);
		}
		else
		{
			for (var i = 0; i < blocks.length; i++)
			{
				if (i == 0)
				{
					
					this.deserializeEvaluationData(blocks[i]);
				}
				else if (i == 1)
				{
				 	
					this.deserializeLastVisitedLocations(blocks[i]);
				}
			}
		}
	}
}
LMSSuspendDataSerializer.prototype.deserializeEvaluationData = function(serializeddata)
{
	if (serializeddata && serializeddata != '')
	{
		var evalentries = serializeddata.split('x');
		for (var i = 0; i < evalentries.length; i++)
		{
			try
			{
				if (evalentries[i] != '')
					eval('this.createResultData(' + evalentries[i] + ');');
			}
			catch (e)
			{
				
			}
		}
	}
}
LMSSuspendDataSerializer.prototype.deserializeLastVisitedLocations = function(serializeddata)
{
	if (serializeddata && serializeddata != '')
	{
		var entries = serializeddata.split('x');
		for (var i = 0; i < entries.length; i++)
		{
			try
			{
				if (entries[i] != '')
					eval('this.createLastVisitedLocation(' + entries[i] + ');');
			}
			catch (e)
			{
				
			}
		}
	}
}
LMSSuspendDataSerializer.prototype.createResultData = function(index, trace, numCorrect, numCorrectStatus, numWrongStatus, numTouched,
																	numTotal, numWrong,
																	numCorrectSystem, numWrongSystem)
{
	var evalentry = this.evaluationService.getEvaluationEntryByIndex(index);
	if (evalentry)
	{
		var resultdata = null;
		if (trace)
		{
			resultdata = new ResultData(trace, numTouched, numTotal, numCorrect, numWrong,
					numCorrectStatus, numWrongStatus,
					numCorrectSystem, numWrongSystem);
		}
		else
		{
			resultdata = new ResultData(trace, 0, 0, numCorrect, 0,
					numCorrectStatus, numWrongStatus, 0, 0);
		}
		evalentry.setData(resultdata);
	}
}
LMSSuspendDataSerializer.prototype.createLastVisitedLocation = function(folderIndex, entryIndex)
{
	var folder = this.structureService.getStructureEntryByIndex(this.structureName, folderIndex);
	if (folder)
	{
		var entry = this.structureService.getStructureEntryByIndex(this.structureName, entryIndex);
		if (entry)
			this.locationService.setLastVistedLocation(folder, entry);
	}
}
LMSSuspendDataSerializer.prototype.trim = function(inputString) {
   if (typeof inputString != "string") { return inputString; }
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
   while (ch == " ") { 
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length-1, retValue.length);
   while (ch == " ") { 
      retValue = retValue.substring(0, retValue.length-1);
      ch = retValue.substring(retValue.length-1, retValue.length);
   }
   while (retValue.indexOf("  ") != -1) { 
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ")+1, retValue.length); 
   }
   return retValue; 
}
