/*
 <DEPENDENCIES>
	 <DEPENDS>Logger</DEPENDS>
	 <DEPENDS>Actions</DEPENDS>
	 <DEPENDS>Broker</DEPENDS>
 </DEPENDENCIES>
 */
ToggleStatic.prototype = new Broker();
ToggleStatic.prototype.constructor = ToggleStatic;
ToggleStatic.superclass = Broker.prototype;
function ToggleStatic(sId, propertyKey, toggleOn)
{
	if (sId)
	{
		this.init(sId, propertyKey, toggleOn);
	}
}
ToggleStatic.prototype.init = function(sId, propertyKey, toggleOn)
{
	this.sId = sId;
	this.propertyKey = propertyKey;
	this.toggleOn = toggleOn;
	this.service = null;
	ToggleStatic.superclass.init.call(this, 'ToggleDynamic');
}
ToggleStatic.prototype.start = function()
{
	this.initService();
	this.checkState();
}
ToggleStatic.prototype.getCheckAction = function()
{
	return new ObjectMethodAction(this, 'check');
}
ToggleStatic.prototype.check = function()
{
	this.checkState();
	if (this.toggleOn == true)
		this.doToggleOn();
	else
		this.doToggleOff();
}
ToggleStatic.prototype.addToggleOnHandle = function(action)
{
	this.registerAction('toggleOn', action);
}
ToggleStatic.prototype.doToggleOn = function()
{
	this.getMessage('toggleOn');
}
ToggleStatic.prototype.addToggleOffHandle = function(action)
{
	this.registerAction('toggleOff', action);
}
ToggleStatic.prototype.doToggleOff = function()
{
	this.getMessage('toggleOff');
}
ToggleStatic.prototype.setOn = function()
{
	if (this.toggleOn == false)
	{
		this.setState(true);
		this.toggleOn = true;
	}
}
ToggleStatic.prototype.isOn = function()
{
	return this.toggleOn;
}
ToggleStatic.prototype.isOff = function()
{
	return !this.toggleOn;
}
ToggleStatic.prototype.setOff = function()
{
	if (this.toggleOn == true)
	{
		this.setState(false);
		this.toggleOn = false;
	}
}
ToggleStatic.prototype.checkState = function()
{
	if (this.service)
	{
		var on = this.service.getPropertyValue(this.propertyKey);
		if (on != true)
			on = false;
		this.toggleOn = on;
	}
}
ToggleStatic.prototype.setState = function(state)
{
	if (this.service)
		this.service.setPropertyValue(this.propertyKey, state);
}
ToggleStatic.prototype.initService = function()
{
	var serviceregistry = ServiceRegistryAccess.getServiceRegistry();
	if (serviceregistry)
		this.service = serviceregistry.getService("propertyservice");
}
ToggleStatic.prototype.getSetOffAction = function()
{
	return new ObjectMethodAction(this, 'setOff');
}
ToggleStatic.prototype.getSetOnAction = function()
{
	return new ObjectMethodAction(this, 'setOn');
}
